package com.zgiot.zx.workflow.controller;

import com.zgiot.zx.workflow.base.Ret;
import com.zgiot.zx.workflow.dto.WorkTemplateResDTO;
import com.zgiot.zx.workflow.entity.TemplateDO;
import com.zgiot.zx.workflow.service.IWorkTemplateService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author jobob
 * @since 2019-05-08
 */
@Slf4j
@RestController
@RequestMapping("/task/work-template")
public class WorkTemplateController {
    @Autowired
    private IWorkTemplateService workTemplateService;
/*
    @Autowired
    private IWorkTemplateFieldService workTemplateFieldService;

    @Autowired
    private RepositoryService repositoryService;

    @Autowired
    private IProcessFileService iProcessFileService;

    @Autowired
    private IWorkPermissionService workPermissionService;

    @Autowired
    private IWorkApproveService workApproveService;

    @Autowired
    private IWorkTemplateOtherSettingsService workTemplateOtherSettingsService;

    @Autowired
    private IProcessGatewayService processGatewayService;*/



  /*  @Value("${template.processfile.path}")
    private String processPath;

    Logger logger = LoggerFactory.getLogger(ProcessFileServiceImpl.class);

    private static final String TEMPLATE_ID = "TEMPLATE_ID";*/

   /* *//**
     * 按id查询
     *//*
    @GetMapping("/getTemplateById")
    @ApiOperation(value = "按id查询一条数据")
    public Ret<TemplateDO> getTemplateById(@RequestParam String id) {
         return  Ret.ok().setData(workTemplateService.getById(id));
    }*/

 /*   *//**
     * 插入一条数据
     *//*
    @PostMapping("/insertOne")
    @ApiOperation(value = "新建模板生成id")
    public Ret insertOne(@RequestBody TemplateDO templateDO) {
        if (workTemplateService.saveTemplateService(templateDO)) {
            return Ret.ok().setData(templateDO);
        } else {
            return Ret.error().setMsg("插入异常");
        }
    }*/

   /* *//**
     * 按id删除一条数据
     *//*
    @DeleteMapping("/deleteOne/{id}")
    @ApiOperation(value = "按id删除一条数据")
    public Ret deleteOne(@PathVariable Integer id) {
        if (workTemplateService.removeById(id)) {
            return Ret.ok().setMsg("删除成功");
        }
        return Ret.error().setMsg("删除失败");
    }*/

   /* *//**
     * 修改一条数据
     *//*
    @PutMapping("/updateOne")
    @ApiOperation(value = "修改一条数据")
    public Ret updateOne(@RequestBody TemplateDO templateDO) {
        if (templateDO.getId() != null) {
            templateDO.setUpdateTime(new Date());
            if (workTemplateService.updateById(templateDO)) {
                return Ret.ok().setMsg("修改成功");
            }
            return Ret.error().setMsg("修改失败");
        }
        return Ret.error().setMsg("缺少id");
    }*/

    /*
    * 发布数据
    * */
    @PostMapping("/publish")
    @ApiOperation(value = "发布数据")
    public Ret publishOne(@RequestBody  TemplateDO templateDo) {
        //System.out.println("模板id："+templateDo.getId());
        if (templateDo.getId() != null) {
            if (workTemplateService.publishBytemplate(templateDo)) {
                return Ret.ok().setMsg("发布成功");
            }
            return Ret.error().setMsg("发布失败");
        }
        return Ret.error().setMsg("缺少id");
    }
   /* *//**
     * 条件查询多条数据
     *//*
    @GetMapping("/")
    @ApiOperation(value = "条件查询多条数据")
    public Ret<List<TemplateDO>> searchSelective(TemplateDO templateDO) {
        return Ret.ok().setData(workTemplateService.getTemplateList(templateDO));
    }
*/
  /*  *//**
     * 条件查询多条数据（分页）
     *//*
    @GetMapping("/page")
    @ApiOperation(value = "条件查询多条数据（分页）")
    public Ret<IPage<TemplateDO>> searchSelectiveByPage(TemplateDO templateDO, Integer page, Integer size) {
        return Ret.ok().setData(workTemplateService.getTemplatePage(templateDO,page,size));
    }
*/
    @GetMapping("/getAllTemplates")
    @ApiOperation(value = "获取所有的模板数据[带分类]")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ifEnable", value = "是否启用(1：是；0：否)", required = true),
            @ApiImplicitParam(name = "ifPhone", value = "是否手机端创建(1：是；0：否)", required = true)
    })
    public Ret getAllTemplates(String ifEnable, String ifPhone) {
        return Ret.ok().setData(workTemplateService.getAllTemplates(ifEnable,ifPhone));
    }

/*
    @GetMapping("/getTemplatesByTp")
    @ApiOperation(value = "根据模板分组查询模板")
    public Ret getTemplatesByTp(String workTpId) {
        QueryWrapper qw = new QueryWrapper();
        qw.eq("work_tp_id",workTpId);
        qw.eq("if_enable","1");
        return Ret.ok().setData(workTemplateService.list(qw));
    }*/

   /* @GetMapping("/getTemplates")
    @ApiOperation(value = "查询已发布模板")
    public Ret getTemplates() {
        QueryWrapper qw = new QueryWrapper();
        qw.eq("if_enable","1");
        return Ret.ok().setData(workTemplateService.list(qw));
    }
*/
    /**
     * @param templateId 模板ID
     * @return
     *//*
    @GetMapping("/deployProcess")
    @ApiOperation(value = "部署流程文件")
    public Ret deployProcess(String templateId) {
        return  workTemplateService.deployProcess(templateId);
    }
*/
    /**
     * 查询模板所有信息（4个分类）
     */
    @GetMapping("/queryTemplateByTemplateId")
    @ApiOperation(value = "查询模板所有信息（4个分类)")
    public Ret<WorkTemplateResDTO> queryTemplateByTemplateId(String templateId) {
        return Ret.ok().setData(workTemplateService.getTemplateByTemplateId(templateId));
    }

    /**
     * 保存模板信息
     */
    @PostMapping("/saveTemplate")
    @ApiOperation(value = "保存模板所有信息（4个分类)")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "templateId", value = "模板Id", required = true),
            @ApiImplicitParam(name = "templateDO", value = "模板基础信息", required = false),
            @ApiImplicitParam(name = "fieldJsonStr", value = "表单信息json字符串", required = false),
            @ApiImplicitParam(name = "xmlJson", value = "工作流文件字符串", required = false),
            @ApiImplicitParam(name = "templateApproveDOList", value = "表单人员配置", required = false),
            @ApiImplicitParam(name = "permissionJson", value = "表单权限配置json", required = false),
            @ApiImplicitParam(name = "processGatewayList", value = "流程表达式", required = false),
            @ApiImplicitParam(name = "templateOtherSettings", value = "模板其他设置", required = false)
    })
    public Ret saveTemplate(@RequestBody WorkTemplateResDTO workTemplateResDTO) {
        return workTemplateService.saveTemplateAll(workTemplateResDTO);
    }

      /**
     * 删除模板
     *//*
    @DeleteMapping("/removeTemplate{id}")
    @ApiOperation(value = "删除模板")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "模板Id", required = true),
    })
    public Ret removeTemplate(@PathVariable String id){
        if(!workTemplateService.removeTemplate(id)){
            return Ret.error().setMsg("删除失败");
        }
        return Ret.ok().setMsg("删除成功");
    }

    *//**
     * 模板复制
     *//*
    @PostMapping("/templateCopy")
    @ApiOperation(value = "模板复制")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "templateId", value = "模板Id", required = true),
            @ApiImplicitParam(name = "workTpId", value = "分类id", required = true)
    })
    public Ret templateCopy(String templateId, String workTpId) {
        boolean flag = workTemplateService.templateCopy(templateId, workTpId);
        if (!flag) {
            return Ret.error().setMsg("复制失败");
        }
        return Ret.ok().setMsg("复制成功");
    }

    *//**
     * 模板移动
     *//*
    @PostMapping("/templateMove")
    @ApiOperation(value = "模板移动")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "templateId", value = "模板Id", required = true),
            @ApiImplicitParam(name = "workTpId", value = "分类id", required = true)
    })
    public Ret templateMove(String templateId, String workTpId) {
        if (!workTemplateService.updateTemplateMove(templateId,workTpId)) {
            return Ret.error().setMsg("移动失败");
        }
        return Ret.ok().setMsg("移动成功");

    }
*/
}
