package com.zgiot.zx.workflow.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.zgiot.zx.workflow.dto.MTUserInfoRspDTO;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * <p>
 * </p>
 *
 * @author jobob
 * @since 2019-05-16
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("workflow_template_approve_hi")
public class TemplateApproveHi implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId("id")
    private String id;

    /**
     * 模板主键
     */
    @TableField("template_id")
    private String templateId;

    /**
     * 流程节点主键
     */
    @TableField("activity_id")
    private String activityId;

    /**
     * 流程节点名称
     */
    @TableField("activity_nm")
    private String activityNm;

    /**
     * 审批人员类型（1：指定人员2：指定角色3.创建人自选4.由上级指定）
     */
    @TableField("person_type")
    private String personType;

    /**
     * 审批人员数据
     */
    @TableField("person_data")
    private String personData;

    /**
     * 审批方式（1：依次2：会签3：或签）
     */
    @TableField("approve_type")
    private String approveType;

    /**
     * 审批人员为空时处理方式（1：自动通过 2：转交管理员）
     */
    @TableField("person_null")
    private String personNull;

    /**
     * 是否是审批节点(1：是 0：否)
     */
    @TableField("if_approve_node")
    private String ifApproveNode;

    /**
     * 是否抄送
     */
    @TableField("if_copy")
    private String ifCopy;

    /**
     * 节点配置按钮项
     */
    @TableField("buttons")
    private String buttons;

    @TableField(exist = false)
    private String workId;

    @TableField(exist = false)
    private MTUserInfoRspDTO mtUserInfoRspDTO;

}
