package com.zgiot.zx.workflow.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * <p>
 * </p>
 *
 * @author jobob
 * @since 2019-05-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("workflow_template")
public class TemplateDO implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 工单模板主键
     */
    @TableId("id")
    private String id;

    /**
     * 模板名称
     */
    @TableField("template_nm")
    private String templateNm;
    /**
     * 模板类型
     */
    @TableField("type_template")
    private String typeTemplate;

    /**
     * 工单类型主键
     */
    @TableField("work_tp_id")
    private String workTpId;

    /**
     * 是否允许手机创建（1：是；0：否）
     */
    @TableField("phone")
    private String phone;

    /**
     * 可创建工单的角色（多个）
     */
    @TableField("create_roles")
    private String createRoles;

    /**
     * 可管理导出模板的角色（多个）
     */
    @TableField("manager_roles")
    private String managerRoles;

    /**
     *模板说明
     */
    @TableField("template_explain")
    private String templateExplain;

    /**
     * 是否启用 1：启动 0：停用
     */
    @TableField("if_enable")
    private String ifEnable;

    /**
     * icon
     */
    @TableField("icon_image")
    private String iconImage;
    @TableField("status")
    private String status;



    /**
     * 创建时间
     */
    @TableField("create_time")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date createTime;

    /**
     * 更新时间
     */
    @TableField("update_time")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date updateTime;



}
