package com.zgiot.zx.workflow.enums;

/**
 * 工单状态枚举类
 */
public enum TaskStatus {

    /**
     * 0、1、2、3 、7、8、9为工单整体状态
     * 4、5、6 为工单进度状态
     */
    DRAFT("0","草稿"),
    EXECUTE("1","执行中"),
    APPROVE("2","审批中"),
    COMPLETE("3","已完成"),
    QUICKLY("4","尽快完成"),
    DELAY("5","延期"),
    OVERDUE("6","逾期"),
    ARCHIVE("7","归档"),
    STOP("8","中止"),
    DELETE("9","删除");

    private final String key;

    private final String value;

    private TaskStatus(String key,String value){
        this.key = key;
        this.value = value;
    }

    public String getKey() {
        return key;
    }

    public String getValue() {
        return value;
    }
}
