package com.zgiot.zx.workflow.filters;

import com.zgiot.zx.workflow.mapper.SUserMapper;
import org.springframework.beans.factory.annotation.Autowired;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

@WebFilter(filterName = "adminFilter",
        urlPatterns = "/*"  /*通配符（*）表示对所有的web资源进行拦截*/
        )
public class Filter implements javax.servlet.Filter {

    @Autowired
    SUserMapper sUserMapper;

    public void destroy() {
    }

    public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain)
            throws ServletException, java.io.IOException {

        HttpServletRequest request = (HttpServletRequest) req;
        HttpServletResponse response = (HttpServletResponse) resp;

        //获取token后拼接的用户id
        String token = request.getHeader("Authorization");
        if(token != null && !"".equals(token)){
            String userId = token.substring(token.indexOf("KL92HAQ") + 7, token.lastIndexOf("KL92HAQ"));
            if("".equals(userId)){
                response.getWriter().write("{\"code\":400,\"message\":\"未登陆\"}");
            }
            //获取管理员code
            String adminCode = sUserMapper.getAdminCode();
            //获取当前登陆用户的code
            List<String> userCode = sUserMapper.getUserCode(userId);

            if(userCode.contains(adminCode)){
                //当前登陆用户的code和管理员相同，不进行拦截
                chain.doFilter(req, resp);
            } else {
                if("XMLHttpRequest".equalsIgnoreCase(request
                        .getHeader("X-Requested-With"))){
                    response.getWriter().write("{\"code\":401,\"message\":\"当前登陆用户无权限\"}");
                } else {
                    response.getWriter().write("{\"code\":401,\"message\":\"当前登陆用户无权限\"}");
                }
                //当前登陆用户的code和管理员不相同，进行拦截并返回首页

            }
        } else {
            response.getWriter().write("{\"code\":400,\"message\":\"未登录\"}");
        }

    }

    public void init(FilterConfig config) throws ServletException {

    }

}
