package com.zgiot.zx.workflow.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zgiot.zx.workflow.entity.SDept;
import com.zgiot.zx.workflow.entity.SUser;
import com.zgiot.zx.workflow.entity.TbUser;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author jobob
 * @since 2019-05-22
 */
@Repository
public interface SUserMapper extends BaseMapper<SUser> {

    @Select("<script>select * from s_user where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = 0 </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = 1 </if>" +
            "and  DEPT_ID = #{businessId}"
            + "</script>")
    List<SUser> querySUsers(SDept sDept);

    @Select("<script>select code from s_user su " +
            "left join s_user_role sur on su.business_id = sur.user_id " +
            "left join s_role sr on sr.business_id = sur.role_id " +
            "where su.del_flag = '0' " +
            "and su.flag = '1' " +
            "and sr.del_flag = '0' " +
            "and sr.flag = '1' " +
            "and su.business_id = #{userId} "
            + "</script>")
    List<String> getUserCode(@Param("userId") String userId);

    @Select("select value from s_dictionary where type = 'ADMIN'")
    String getAdminCode();
}
