package com.zgiot.zx.workflow.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zgiot.zx.workflow.entity.TemplateApproveDO;
import com.zgiot.zx.workflow.entity.TemplateFormFieldDO;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author jobob
 * @since 2019-05-16
 */
public interface WorkApproveMapper extends BaseMapper<TemplateApproveDO> {

    /**
     * 根据模版id和节点id查询角色名称（该方法只用于停送电）
     * @param templateId
     * @param activityId
     * @return
     */
    String getRoleNameByTemplateIdAndActivityId(String templateId, String activityId);

    List<TemplateApproveDO> selectApproveData(TemplateApproveDO templateApproveDO);

    @Delete("<script>delete " +
            "from " +
            "workflow_template_approve " +
            "where activity_id not In(" +
            "<foreach collection =\"activitis\" item=\"item\"  separator=\",\">" +
            "#{item}" +
            "</foreach>" +
            ") AND template_id = #{templateId} " +
            "</script>")
    boolean deleteByActivitiId(@Param("activitis")List<String> activitis,@Param("templateId")String templateId);


}
