package com.zgiot.zx.workflow.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zgiot.zx.workflow.dto.WorkPermissionResDTO;
import com.zgiot.zx.workflow.entity.TemplatePermissionDO;
import com.zgiot.zx.workflow.entity.TemplatePermissionHi;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author jobob
 * @since 2019-05-08
 */
@Repository
public interface WorkPermissionHiMapper extends BaseMapper<TemplatePermissionHi> {

    @Insert("<script>insert into workflow_template_permission_hi(id,template_id,activity_id,field_id,permission,if_write)" +
            "values " +
            "<foreach collection=\"listTemPerHi\" item=\"items\" separator=\",\" >" +
            "( #{items.id},#{items.templateId},#{items.activityId},#{items.fieldId}," +
            "#{items.permission},#{items.ifWrite}" +
            ")</foreach></script>")
    boolean insertPermissionHi(@Param("listTemPerHi") List<TemplatePermissionDO> templatePermissionHiList);

}
