package com.zgiot.zx.workflow.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zgiot.zx.workflow.dto.WorkPermissionResDTO;
import com.zgiot.zx.workflow.entity.TemplateFormFieldDO;
import com.zgiot.zx.workflow.entity.TemplatePermissionDO;
import org.activiti.bpmn.model.UserTask;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author jobob
 * @since 2019-05-08
 */
public interface WorkPermissionMapper extends BaseMapper<TemplatePermissionDO> {

    @Select("" +
            "select * from workflow_template_permission a " +
            "left join workflow_template_form_field b on a.field_id = b.id " +
            "where a.permission ='0' and a.activity_id =#{activityId} and a.template_id =#{templateId}" +
            "order by b.field_order asc")
    List<WorkPermissionResDTO> queryPermissionAndFieldByNode(@Param("activityId") String activityId, @Param("templateId") String templateId);

    List<WorkPermissionResDTO> selectListByTemplateId(String templateId);

   @Select("<script>select * from workflow_template_permission " +
           "where template_id=#{templateId} " +
           "and field_id=#{id} " +
           "</script>")
    List<TemplatePermissionDO> workPermissionByTemplateFormFieldDO(TemplateFormFieldDO templateFormFieldDO);

   @Delete("<script>delete " +
           "from " +
           "workflow_template_permission " +
           "where activity_id not In(" +
           "<foreach collection =\"activits\" item=\"item\"  separator=\",\">" +
           "#{item}" +
           "</foreach>" +
           ") AND template_id = #{templateId}" +
           "</script>")
   boolean deleteByActivitiId(@Param("activits") List<String> activitis,@Param("templateId")String template);
}

