package com.zgiot.zx.workflow.service.impl;

import cn.hutool.core.util.IdUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.zgiot.zx.workflow.entity.TemplateProcessFileDO;
import com.zgiot.zx.workflow.mapper.ProcessFileMapper;

import com.zgiot.zx.workflow.mapper.WorkApproveMapper;

import com.zgiot.zx.workflow.service.IProcessFileService;

import org.activiti.bpmn.converter.BpmnXMLConverter;
import org.activiti.bpmn.model.BpmnModel;
import org.activiti.bpmn.model.FlowNode;
import org.activiti.bpmn.model.Process;
import org.activiti.bpmn.model.SequenceFlow;
import org.activiti.engine.*;
import org.activiti.engine.history.HistoricActivityInstance;
import org.activiti.engine.history.HistoricProcessInstance;
import org.activiti.engine.history.HistoricTaskInstance;
import org.activiti.engine.history.HistoricVariableInstance;
import org.activiti.engine.impl.RepositoryServiceImpl;
import org.activiti.engine.impl.javax.el.ExpressionFactory;
import org.activiti.engine.impl.javax.el.ValueExpression;
import org.activiti.engine.impl.juel.ExpressionFactoryImpl;
import org.activiti.engine.impl.juel.SimpleContext;
import org.activiti.engine.impl.persistence.entity.ExecutionEntity;
import org.activiti.engine.impl.persistence.entity.ProcessDefinitionEntity;
import org.activiti.engine.runtime.ProcessInstance;
import org.activiti.engine.task.IdentityLink;
import org.activiti.engine.task.Task;
import org.activiti.image.ProcessDiagramGenerator;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.multipart.MultipartFile;

import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-05-08
 */
@Service
public class ProcessFileServiceImpl extends ServiceImpl<ProcessFileMapper, TemplateProcessFileDO> implements IProcessFileService {

   /* @Autowired
    private RuntimeService runtimeService;

    @Autowired
    private TaskService taskService;

    @Autowired
    private HistoryService historyService;

    @Autowired
    private RepositoryService repositoryService;

    @Autowired
    IdentityService identityService;

    @Autowired
    ProcessEngineConfiguration processEngineConfiguration;

    @Autowired
    ProcessEngine processEngineFactory;

    @Autowired
    private ProcessEngine processEngine;

    @Autowired
    private WorkApproveMapper workApproveMapper;

    @Autowired
    TbUserMapper tbUserMapper;

    @Autowired
    private ITaskDataService taskDataService;

    @Autowired
    private WorkBaseMapper workBaseMapper;

    @Autowired
    private ITaskInfoService taskInfoService;

    @Autowired
    private IWorkBaseService workBaseService;*/

    @Value("${template.processfile.path}")
    private String processPath;

    Logger logger = LoggerFactory.getLogger(ProcessFileServiceImpl.class);

  /*  *//**
     * 上传流程文件并与模板建立关联（一个模板对应一个唯一的流程文件）
     *
     * @param file
     * @param tempId
     * @param savePath
     * @return
     *//*
    @Override
    @Transactional
    public boolean uploadProcessFile(MultipartFile file, String tempId, String savePath) {
        try {
            //先清除之前与模板关联的流程文件
            QueryWrapper qw = new QueryWrapper();
            qw.eq("TEMPLATE_ID", tempId);
            List<TemplateProcessFileDO> list = baseMapper.selectList(qw);
            if (list != null && !list.isEmpty()) {
                for (TemplateProcessFileDO pf : list) {
                    baseMapper.deleteById(pf.getId());
                }
            }
            //保存上传文件路劲
            TemplateProcessFileDO templateProcessFileDO = new TemplateProcessFileDO();
            templateProcessFileDO.setId(IdUtil.randomUUID());
            templateProcessFileDO.setProcessFilePath(savePath + file.getOriginalFilename());
            templateProcessFileDO.setTemplateId(tempId);
            templateProcessFileDO.setProcessFileNm(file.getOriginalFilename());
            //默认“未部署”
            templateProcessFileDO.setIfDeploy("0");
            baseMapper.insert(templateProcessFileDO);
            return true;
        } catch (Exception e) {
            logger.error(e.getMessage());
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
        }
        return false;
    }*/

    /**
     * 上传流程文件并与模板建立关联（一个模板对应一个唯一的流程文件）
     *
     * @param fileName
     * @param tempId
     * @param savePath
     * @return
     */
    @Override
    @Transactional
    public boolean uploadProcessFileByFileName(String fileName, String tempId, String savePath) {
        try {
            //先清除之前与模板关联的流程文件
            QueryWrapper qw = new QueryWrapper();
            qw.eq("TEMPLATE_ID", tempId);
            List<TemplateProcessFileDO> list = baseMapper.selectList(qw);
            if (list != null && !list.isEmpty()) {
                for (TemplateProcessFileDO pf : list) {
                    baseMapper.deleteById(pf.getId());
                }
            }
            //保存上传文件路劲
            TemplateProcessFileDO templateProcessFileDO = new TemplateProcessFileDO();
            templateProcessFileDO.setId(IdUtil.randomUUID());
            templateProcessFileDO.setProcessFilePath(fileName);
            templateProcessFileDO.setTemplateId(tempId);
            templateProcessFileDO.setProcessFileNm(fileName);
            //默认“未部署”
            templateProcessFileDO.setIfDeploy("0");
            int insert = baseMapper.insert(templateProcessFileDO);
            return true;
        } catch (Exception e) {
            logger.error(e.getMessage());
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
        }
        return false;
    }

   /* *//**
     * 根据流程文件获取流程文件的唯一ID
     *
     * @param bpmnName
     * @return
     *//*
    @Override
    public String queryBPMNkey(String bpmnName) {
        File processFile = new File(processPath + bpmnName);
        XMLInputFactory xif = XMLInputFactory.newInstance();
        InputStreamReader in;
        XMLStreamReader xtr;
        String bpmnKey = "";
        try {
            in = new InputStreamReader(new FileInputStream(processFile));
            xtr = xif.createXMLStreamReader(in);
            BpmnModel model = new BpmnXMLConverter().convertToBpmnModel(xtr);
            if (model != null) {
                List<Process> process = model.getProcesses();
                bpmnKey = process.get(0).getId();
            }
        } catch (Exception e) {
            logger.error("文件读取错误");
        }
        return bpmnKey;
    }*/
/*

    */
/**
     * 发起流程
     *
     * @param key           流程key
     * @param bussinessKey  业务key,可为null
     * @param formjson      表单数据
     * @param variablesjson 其他变量数据
     * @param userId        发起人id
     * @param userName      发起人姓名
     * @return 流程实例id
     *//*

    @Override
    public String startProcess(String key, String bussinessKey, String formjson, Map variablesjson, String userId, String userName,
            String templateId) {

        //设置流程变量
        Map<String, Object> variables = new HashMap<>();
        //查询表单所有变量
        QueryWrapper qw = new QueryWrapper();
        qw.eq("WORK_ID", bussinessKey);
        List<TaskDataDO> taskDataDOList = taskDataService.list(qw);
        for (TaskDataDO taskDataDO : taskDataDOList) {
            variables.put(taskDataDO.getFieldId(), taskDataDO.getFieldValue());
        }
        variables.put("flag","1");
        MTMyInfoRspDTO.CorpUsersBean.CorpBean.DeptsBean dept = workBaseService.getUserDept();
        variables.put("deptId",dept.getId());
        try {
            identityService.setAuthenticatedUserId(userId);
            ExecutionEntity instance = (ExecutionEntity) runtimeService.startProcessInstanceByKey(key, bussinessKey, variables);
            List<Task> nextTaskList = taskService
                    .createTaskQuery()
                    .processInstanceId(instance.getProcessInstanceId())
                    .list();
            //启动流程回调
            taskInfoService.startProcessCallback(nextTaskList,bussinessKey,userId);
            return instance.getProcessInstanceId();
        } catch (Exception e) {
            logger.error("发起流程失败");
        }

        return null;
    }
*/

  /*  *//**
     * 此方法描述的是： 查看我的任务列表
     *
     * @param assignee
     * @return List<Task>
     *//*
    @Override
    public List<TaskResDTO> getTasks(String assignee) {
        List<Task> tasks = taskService.createTaskQuery().taskCandidateOrAssigned(assignee).orderByTaskCreateTime().desc().list();
        List<TaskResDTO> vos = new ArrayList<>();
        for (Task task : tasks) {
            TaskResDTO vo = new TaskResDTO();
            Object formdata = taskService.getVariable(task.getId(), "formData");
            vo.setTaskId(task.getId());
            vo.setTaskName(task.getName());
            vo.setTaskDefinitionKey(task.getTaskDefinitionKey());
            vo.setProcDefId(task.getProcessDefinitionId());
            vo.setProInsId(task.getProcessInstanceId());
            if (formdata != null) {
                Map maps = (Map) JSON.parse(formdata.toString());
                vo.setFormdata(maps);
            }

            vos.add(vo);
        }

        return vos;
    }
*/
   /* @Override
    public List<TaskResDTO> getHistoryTasks(String assignee) {
        List<HistoricTaskInstance> hisTaskList = historyService.createHistoricTaskInstanceQuery().taskCandidateUser(assignee).orderByTaskId().desc()
                .list();
        List<HistoricTaskInstance> hisTaskList2 = historyService.createHistoricTaskInstanceQuery().taskAssignee(assignee).orderByTaskId().desc()
                .list();
        hisTaskList.addAll(hisTaskList2);
        List<TaskResDTO> vos = new ArrayList<>();
        for (HistoricTaskInstance task : hisTaskList) {
            TaskResDTO vo = new TaskResDTO();

            vo.setTaskId(task.getId());
            vo.setTaskName(task.getName());
            vo.setTaskDefinitionKey(task.getTaskDefinitionKey());
            vo.setProcDefId(task.getProcessDefinitionId());
            vo.setProInsId(task.getProcessInstanceId());
            vos.add(vo);
        }

        return vos;
    }
*/
    /**
     * 获取用户在某流程实例中的待办
     *
     * @param assignee
     * @param processId
     * @return
     *//*
    @Override
    public Task getSingleTask(String assignee, String processId) {
        List<Task> tasks = taskService.createTaskQuery().taskCandidateOrAssigned(assignee).orderByTaskCreateTime().desc().list();
        if (tasks != null) {
            for (Task task : tasks) {
                if (processId.equals(task.getProcessInstanceId())) {
                    return task;
                }
            }
        }
        return null;
    }
*/
   /* *//**
     * 通过任务id获取任务信息
     *
     * @param taskid
     * @return
     *//*
    @Override
    public TaskResDTO getTaskbyId(String taskid,String userId,String taskStatus) {
        TaskResDTO vo = new TaskResDTO();
        if("0".equals(taskStatus)){
            Task tasks = taskService.createTaskQuery().taskId(taskid).singleResult();
            vo.setTaskId(tasks.getId());
            vo.setTaskName(tasks.getName());
            vo.setTaskDefinitionKey(tasks.getTaskDefinitionKey());
            vo.setProcDefId(tasks.getProcessDefinitionId());
            vo.setProInsId(tasks.getProcessInstanceId());
            vo.setActivityId(tasks.getTaskDefinitionKey());
        }else{
            List<HistoricTaskInstance> hisTaskList = historyService.createHistoricTaskInstanceQuery().taskCandidateUser(userId).orderByTaskId().desc()
                    .list();
            for (HistoricTaskInstance task : hisTaskList) {
                if(taskid.equals(task.getId())){
                    vo.setTaskId(task.getId());
                    vo.setTaskName(task.getName());
                    vo.setTaskDefinitionKey(task.getTaskDefinitionKey());
                    vo.setProcDefId(task.getProcessDefinitionId());
                    vo.setProInsId(task.getProcessInstanceId());
                    vo.setActivityId(task.getTaskDefinitionKey());
                    TaskResDTO taskResDTO = getCurrentTask(task.getProcessInstanceId());
                    vo.setCandidates(taskResDTO.getCandidates());
                }
            }
        }
        return vo;
    }*/

 /*   *//**
     * 方法描述：获取流程当前任务节点
     *
     * @param processInstanceId
     * @return
     *//*
    @Override
    public TaskResDTO getCurrentTask(String processInstanceId) {
        List<Task> tasks = taskService.createTaskQuery().processInstanceId(processInstanceId).orderByTaskCreateTime().desc().list();

        TaskResDTO vo = new TaskResDTO();
        // 已经完结
        if (tasks == null || tasks.isEmpty()) {

            List<HistoricVariableInstance> list = historyService.createHistoricVariableInstanceQuery().processInstanceId(processInstanceId).list();

            for (HistoricVariableInstance hi : list) {
                if (hi.getVariableName().equalsIgnoreCase("formData")) {
                    vo.setProInsId(processInstanceId);
                    Object formdata = hi.getValue();
                    if (formdata != null) {
                        Map maps = (Map) JSON.parse(formdata.toString());
                        vo.setFormdata(maps);
                    }
                }
                if (hi.getVariableName().equalsIgnoreCase("protitle")) {
                    vo.setProTitle(hi.getValue().toString());
                }
            }

            HistoricActivityInstance instances =
                    historyService.createHistoricActivityInstanceQuery().processInstanceId(processInstanceId).listPage(1, 1).get(0);

            vo.setProcDefId(instances.getProcessDefinitionId());
            vo.setCandidates(null);
            vo.setTaskId("-1");
            vo.setTaskName("已完结");

        } else {
            Task task = tasks.get(0);
            Object formdata = taskService.getVariable(task.getId(), "formData");
            vo.setTaskId(task.getId());
            vo.setTaskName(task.getName());
            vo.setTaskDefinitionKey(task.getTaskDefinitionKey());
            vo.setProcDefId(task.getProcessDefinitionId());
            vo.setProInsId(task.getProcessInstanceId());
            vo.setCreateTime(task.getCreateTime());
            if (formdata != null) {
                Map maps = (Map) JSON.parse(formdata.toString());
                vo.setFormdata(maps);
            }

            List<String> peoples = new ArrayList<>();
            for (Task tt : tasks) {
                List<IdentityLink> lt = taskService.getIdentityLinksForTask(tt.getId());
                for (IdentityLink identityLink : lt) {
                    String tempUserId = identityLink.getUserId();
                    peoples.add(tempUserId);
                }
            }

            vo.setCandidates(peoples);
        }

        return vo;

    }
*/
   /* *//**
     * 流程撤回
     *
     * @param taskId
     * @return
     *//*
    @Override
    public boolean retract(String taskId) {
        return true;
    }

    *//**
     * 中止流程
     * @param processId 流程实例id
     * @return
     *//*
    @Override
    public boolean stopProcess(String processId) {
        try{
            runtimeService.deleteProcessInstance(processId,"中止流程");
            return true;
        }catch(Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        return false;
    }
*/
    /**
     * 任务转交
     * 1.删除原任务候选人
     * 2.增加新的任务候选人
     * @param taskId
     * @param userId
     * @param transferUserIds
     * @return
     *//*
    @Override
    public boolean transferTask(String taskId, String userId, String transferUserIds) {
        try{
            String[] transferUserIdArr = transferUserIds.split(",");
            if(transferUserIdArr != null && transferUserIdArr.length > 0){
                taskService.deleteCandidateUser(taskId,userId);
                for(String transferUserId : transferUserIdArr){
                    taskService.addCandidateUser(taskId,transferUserId);
                }
                return true;
            }
        }catch(Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        return false;
    }

*/
    /**
     * 查询流程当前节点的下一步节点。用于流程提示时的提示。
     * @param taskId
     * @return
     * @throws Exception
     *//*
    public Map<String,  FlowNode> findNextTask(String taskId,String workId){
        try{
            Map<String, FlowNode> nodeMap = new HashMap<String, FlowNode>();
            ProcessInstance processInstance = findProcessInstanceByTaskId(taskId);
            //查询流程定义 。
            BpmnModel bpmnModel = repositoryService.getBpmnModel(processInstance.getProcessDefinitionId());
            List<Process> listp = bpmnModel.getProcesses();
            Process process = listp.get(0);
            //当前节点流定义
            Task task=taskService.createTaskQuery() // 创建任务查询
                    .taskId(taskId) // 根据任务id查询
                    .singleResult();
            FlowNode sourceFlowElement = ( FlowNode) process.getFlowElement(task.getTaskDefinitionKey());
            // 找到当前任务的流程变量
            List<HistoricVariableInstance> listVar=historyService.createHistoricVariableInstanceQuery().processInstanceId(processInstance.getId()).list() ;
            iteratorNextNodes(process, sourceFlowElement, nodeMap,listVar,workId);
            return nodeMap;
        }catch(Exception e){
            e.printStackTrace();
        }
        return null;
    }
*/
   /* private ProcessInstance findProcessInstanceByTaskId(String taskId){
        Task task=taskService.createTaskQuery() // 创建任务查询
                .taskId(taskId) // 根据任务id查询
                .singleResult();
        String processInstanceId=task.getProcessInstanceId(); // 获取流程实例id
        ProcessInstance pi = runtimeService.createProcessInstanceQuery() // 根据流程实例id获取流程实例
                .processInstanceId(processInstanceId)
                .singleResult();
        return pi;
    }
*/

 /*   *//**
     * 查询流程当前节点的下一步节点。用于流程提示时的提示。
     * @param process
     * @param sourceFlowElement
     * @param nodeMap
     * @param listVar
     * @throws Exception
     *//*
    private void iteratorNextNodes(Process process, FlowNode sourceFlowElement, Map<String,  FlowNode> nodeMap,List<HistoricVariableInstance> listVar,String workId)
            throws Exception {
        List<SequenceFlow> list = sourceFlowElement.getOutgoingFlows();
        for (SequenceFlow sf : list) {
            sourceFlowElement = ( FlowNode) process.getFlowElement( sf.getTargetRef());
            if(StringUtils.isNotEmpty(sf.getConditionExpression() )){
                ExpressionFactory factory = new ExpressionFactoryImpl();
                SimpleContext context = new SimpleContext();
                for(HistoricVariableInstance var :listVar){
                    context.setVariable(var.getVariableName(), factory.createValueExpression(var.getValue(), var.getValue().getClass()));
                }
                QueryWrapper qw = new QueryWrapper();
                qw.eq("WORK_ID", workId);
                List<TaskDataDO> taskDataDOList = taskDataService.list(qw);
                for (TaskDataDO taskDataDO : taskDataDOList) {
                    context.setVariable(taskDataDO.getFieldId(), factory.createValueExpression(taskDataDO.getFieldValue(),String.class));
                }
                MTMyInfoRspDTO.CorpUsersBean.CorpBean.DeptsBean dept = workBaseService.getUserDept();
                if(dept != null){
                    context.setVariable("deptId",factory.createValueExpression(dept.getId(),String.class));
                }
                context.setVariable("flag",factory.createValueExpression("1",String.class));
                ValueExpression e = factory.createValueExpression(context, sf.getConditionExpression(), boolean.class);
                if((Boolean)e.getValue(context)){
                    nodeMap.put(sourceFlowElement.getId(), sourceFlowElement);
                    break;
                }
            }
            logger.info(String.valueOf(sourceFlowElement.isNotExclusive()));
            if (sourceFlowElement instanceof org.activiti.bpmn.model.UserTask) {
                nodeMap.put(sourceFlowElement.getId(), sourceFlowElement);
            }else if (sourceFlowElement instanceof org.activiti.bpmn.model.ExclusiveGateway || !sourceFlowElement.isNotExclusive()) {
                iteratorNextNodes(process, sourceFlowElement, nodeMap,listVar,workId);
            }
        }
    }
*/

/*

    */
/**
     * 获取流程图像，已执行节点和流程线高亮显示
     *//*

    public InputStream getActivitiProccessImage(String pProcessInstanceId) {
        //logger.info("[开始]-获取流程图图像");
        try {
            //  获取历史流程实例
            HistoricProcessInstance historicProcessInstance = historyService.createHistoricProcessInstanceQuery()
                    .processInstanceId(pProcessInstanceId).singleResult();

            if (historicProcessInstance == null) {
                //throw new BusinessException("获取流程实例ID[" + pProcessInstanceId + "]对应的历史流程实例失败！");
            }
            else
            {
                // 获取流程定义
                ProcessDefinitionEntity processDefinition = (ProcessDefinitionEntity) ((RepositoryServiceImpl) repositoryService)
                        .getDeployedProcessDefinition(historicProcessInstance.getProcessDefinitionId());

                // 获取流程历史中已执行节点，并按照节点在流程中执行先后顺序排序
                List<HistoricActivityInstance> historicActivityInstanceList = historyService.createHistoricActivityInstanceQuery()
                        .processInstanceId(pProcessInstanceId).orderByHistoricActivityInstanceId().asc().list();

                // 已执行的节点ID集合
                List<String> executedActivityIdList = new ArrayList<String>();
                int index = 1;
                //logger.info("获取已经执行的节点ID");
                for (HistoricActivityInstance activityInstance : historicActivityInstanceList) {
                    executedActivityIdList.add(activityInstance.getActivityId());

                    //logger.info("第[" + index + "]个已执行节点=" + activityInstance.getActivityId() + " : " +activityInstance.getActivityName());
                    index++;
                }

                BpmnModel bpmnModel = repositoryService.getBpmnModel(historicProcessInstance.getProcessDefinitionId());

                // 已执行的线集合
                List<String> flowIds = new ArrayList<String>();
                // 获取流程走过的线 (getHighLightedFlows是下面的方法)
                flowIds = getHighLightedFlows(bpmnModel,processDefinition, historicActivityInstanceList);



                // 获取流程图图像字符流
                ProcessDiagramGenerator pec = processEngineFactory.getProcessEngineConfiguration().getProcessDiagramGenerator();
                //配置字体
                InputStream imageStream = pec.generateDiagram(bpmnModel, "png", executedActivityIdList, flowIds,"宋体","微软雅黑","黑体",null,2.0);
                return imageStream;
            }
            //logger.info("[完成]-获取流程图图像");
        } catch (Exception e) {
            System.out.println(e.getMessage());
            //logger.error("【异常】-获取流程图失败！" + e.getMessage());
            //throw new BusinessException("获取流程图失败！" + e.getMessage());
        }
        return null;
    }
*/


   /* public List<String> getHighLightedFlows(BpmnModel bpmnModel,ProcessDefinitionEntity processDefinitionEntity,List<HistoricActivityInstance> historicActivityInstances)
    {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); //24小时制
        List<String> highFlows = new ArrayList<String>();// 用以保存高亮的线flowId

        for (int i = 0; i < historicActivityInstances.size() - 1; i++)
        {
            // 对历史流程节点进行遍历
            // 得到节点定义的详细信息
            FlowNode activityImpl = (FlowNode)bpmnModel.getMainProcess().getFlowElement(historicActivityInstances.get(i).getActivityId());


            List<FlowNode> sameStartTimeNodes = new ArrayList<FlowNode>();// 用以保存后续开始时间相同的节点
            FlowNode sameActivityImpl1 = null;

            HistoricActivityInstance activityImpl_ = historicActivityInstances.get(i);// 第一个节点
            HistoricActivityInstance activityImp2_ ;

            for(int k = i + 1 ; k <= historicActivityInstances.size() - 1; k++)
            {
                activityImp2_ = historicActivityInstances.get(k);// 后续第1个节点

                if ( activityImpl_.getActivityType().equals("userTask") && activityImp2_.getActivityType().equals("userTask") &&
                        df.format(activityImpl_.getStartTime()).equals(df.format(activityImp2_.getStartTime()))   ) //都是usertask，且主节点与后续节点的开始时间相同，说明不是真实的后继节点
                {

                }
                else
                {
                    sameActivityImpl1 = (FlowNode)bpmnModel.getMainProcess().getFlowElement(historicActivityInstances.get(k).getActivityId());//找到紧跟在后面的一个节点
                    break;
                }

            }
            sameStartTimeNodes.add(sameActivityImpl1); // 将后面第一个节点放在时间相同节点的集合里
            for (int j = i + 1; j < historicActivityInstances.size() - 1; j++)
            {
                HistoricActivityInstance activityImpl1 = historicActivityInstances.get(j);// 后续第一个节点
                HistoricActivityInstance activityImpl2 = historicActivityInstances.get(j + 1);// 后续第二个节点

                if (df.format(activityImpl1.getStartTime()).equals(df.format(activityImpl2.getStartTime()))  )
                {// 如果第一个节点和第二个节点开始时间相同保存
                    FlowNode sameActivityImpl2 = (FlowNode)bpmnModel.getMainProcess().getFlowElement(activityImpl2.getActivityId());
                    sameStartTimeNodes.add(sameActivityImpl2);
                }
                else
                {// 有不相同跳出循环
                    break;
                }
            }
            List<SequenceFlow> pvmTransitions = activityImpl.getOutgoingFlows() ; // 取出节点的所有出去的线

            for (SequenceFlow pvmTransition : pvmTransitions)
            {// 对所有的线进行遍历
                FlowNode pvmActivityImpl = (FlowNode)bpmnModel.getMainProcess().getFlowElement( pvmTransition.getTargetRef());// 如果取出的线的目标节点存在时间相同的节点里，保存该线的id，进行高亮显示
                if (sameStartTimeNodes.contains(pvmActivityImpl)) {
                    highFlows.add(pvmTransition.getId());
                }
            }

        }
        return highFlows;

    }
*/
}
