package com.zgiot.zx.workflow.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zgiot.zx.workflow.dto.MTUserInfoRspDTO;
import com.zgiot.zx.workflow.entity.TemplateApproveDO;
import com.zgiot.zx.workflow.enums.TemplateApproveType;
import com.zgiot.zx.workflow.mapper.WorkApproveMapper;
import com.zgiot.zx.workflow.service.IWorkApproveService;
import com.zgiot.zx.workflow.utils.MTCotactApiRequestClient;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-05-16
 */
@Service
public class WorkApproveServiceImpl extends ServiceImpl<WorkApproveMapper, TemplateApproveDO> implements IWorkApproveService {

    Logger logger = LoggerFactory.getLogger(WorkApproveServiceImpl.class);

    private static final String TEMPLATE_ID = "TEMPLATE_ID";

    private static final String ACTIVITY_ID = "ACTIVITY_ID";

   /* @Autowired
    private IWorkflowApproveDataService workflowApproveDataService;
    @Autowired
    private MTCotactApiRequestClient mtCotactApiRequestClient;*/

   /* @Override
    @Transactional
    public Boolean saveWorkApprove(TemplateApproveDO templateApproveDO) {
        try {
            if (templateApproveDO.getTemplateId() == null || "".equals(templateApproveDO.getTemplateId())) {
                return false;
            }
            if (templateApproveDO.getActivityId() == null || "".equals(templateApproveDO.getActivityId())) {
                return false;
            }
            QueryWrapper deleteQw = new QueryWrapper();
            deleteQw.eq(TEMPLATE_ID, templateApproveDO.getTemplateId());
            deleteQw.eq(ACTIVITY_ID, templateApproveDO.getActivityId());
            //保存前先清除之前的数据
            baseMapper.delete(deleteQw);
            templateApproveDO.setId(UUID.randomUUID().toString().replace("-", ""));
            baseMapper.insert(templateApproveDO);
            return true;
        } catch (Exception e) {
            logger.error(e.getMessage());
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
        }
        return false;
    }*/

    @Override
    @Transactional
    public Boolean saveWorkApproveBatch(List<TemplateApproveDO> templateApproveDOList) {
        Set<String> activityList = new HashSet<>();
        for (TemplateApproveDO templateApproveDO : templateApproveDOList) {
            if (templateApproveDO.getTemplateId() == null || "".equals(templateApproveDO.getTemplateId())) {
                return false;
            }
            if (templateApproveDO.getActivityId() == null || "".equals(templateApproveDO.getActivityId())) {
                return false;
            }
            //数据校验,节点是否重复提交
            activityList.add(templateApproveDO.getActivityId());
            QueryWrapper deleteQw = new QueryWrapper();
            deleteQw.eq(TEMPLATE_ID, templateApproveDO.getTemplateId());
            deleteQw.eq(ACTIVITY_ID, templateApproveDO.getActivityId());
            //保存前先清除之前的数据
            baseMapper.delete(deleteQw);
            templateApproveDO.setId(UUID.randomUUID().toString().replace("-", ""));
        }
        if (templateApproveDOList.size() != activityList.size()) {

            return false;
        }
        return this.saveBatch(templateApproveDOList);
    }

   @Override
    public List<TemplateApproveDO> getWorkApprove(String templateId) {
        QueryWrapper qw = new QueryWrapper();
        qw.eq(TEMPLATE_ID, templateId);
        return baseMapper.selectList(qw);
    }

  /*  @Override
    public TemplateApproveDO getApproveByTempIdAndactivityId(String templateId, String acticitiId) {
        QueryWrapper qw = new QueryWrapper();
        qw.eq(TEMPLATE_ID, templateId);
        qw.eq(ACTIVITY_ID, acticitiId);
        return baseMapper.selectOne(qw);
    }*/

   /* @Override
    public List<TemplateApproveDO> getCreatorSelectApprove(String templateId, String workId) {
        TemplateApproveDO templateApproveDO = new TemplateApproveDO();
        templateApproveDO.setPersonType(TemplateApproveType.CREATESELECT.getKey());
        templateApproveDO.setWorkId(workId);
        templateApproveDO.setTemplateId(templateId);
        List<TemplateApproveDO> list = baseMapper.selectApproveData(templateApproveDO);

        if(StringUtils.isBlank(workId)){
            for(TemplateApproveDO templateApproveDO1 : list){
                templateApproveDO1.setPersonData("");
            }
        }else{
            List<String> userIdList = new ArrayList<>();
            for(TemplateApproveDO t : list){
                userIdList.add(t.getPersonData());
            }
            MTUserGetsReqDTO mtUserGetsReqDTO = new MTUserGetsReqDTO();
            mtUserGetsReqDTO.setCorpId("6");
            mtUserGetsReqDTO.setIds(userIdList);
            List<MTUserInfoRspDTO> userList = mtCotactApiRequestClient.userGets(mtUserGetsReqDTO,null);
            Map<String,MTUserInfoRspDTO> userMap = new HashMap();
            for(MTUserInfoRspDTO mtUserInfoRspDTO : userList){
                userMap.put(String.valueOf(mtUserInfoRspDTO.getId()),mtUserInfoRspDTO);
            }
            for(TemplateApproveDO t : list){
                t.setMtUserInfoRspDTO(userMap.get(t.getPersonData()));
            }
        }
        return list;
    }
*/
  /*  @Override
    public void updateCreateSelectApprove(String workApproveData,String workId) throws Exception{
        JSONObject json = JSON.parseObject(workApproveData);
        JSONArray approveData = json.getJSONArray("approveData");
        List<TemplateApproveDataDO> templateApproveDataDOList = new ArrayList<TemplateApproveDataDO>();
        if (approveData != null && !approveData.isEmpty()) {
            for (Object obj : approveData) {
                JSONObject jsonObject = (JSONObject) obj;
                TemplateApproveDataDO templateApproveDataDO = new TemplateApproveDataDO();
                templateApproveDataDO.setId(UUID.randomUUID().toString());
                templateApproveDataDO.setPersonData(jsonObject.get("personData").toString());
                templateApproveDataDO.setActivityId(jsonObject.get("activityId").toString());
                templateApproveDataDO.setWorkId(workId);
                templateApproveDataDOList.add(templateApproveDataDO);
            }
            if(!templateApproveDataDOList.isEmpty()){
                QueryWrapper delQw = new QueryWrapper();
                delQw.eq("work_id",workId);
                //保存之前先根据工单id清除
                workflowApproveDataService.remove(delQw);
                workflowApproveDataService.saveBatch(templateApproveDataDOList);
            }
        }
    }*/
}
