package com.zgiot.zx.workflow.service.impl;

import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.file.FileReader;
import cn.hutool.core.io.file.FileWriter;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zgiot.zx.workflow.base.Ret;
import com.zgiot.zx.workflow.dto.ActivitiResDTO;
import com.zgiot.zx.workflow.dto.TemplateTypeResDTO;
import com.zgiot.zx.workflow.dto.WorkPermissionInfoResDTO;
import com.zgiot.zx.workflow.dto.WorkTemplateResDTO;
import com.zgiot.zx.workflow.entity.*;
import com.zgiot.zx.workflow.mapper.*;
import com.zgiot.zx.workflow.service.*;
import lombok.extern.slf4j.Slf4j;
import org.activiti.bpmn.converter.BpmnXMLConverter;
import org.activiti.bpmn.model.BpmnModel;
import org.activiti.bpmn.model.FlowElement;
import org.activiti.bpmn.model.UserTask;
import org.activiti.engine.ProcessEngine;
import org.activiti.engine.RepositoryService;
import org.activiti.engine.impl.RepositoryServiceImpl;
import org.activiti.engine.impl.pvm.ReadOnlyProcessDefinition;
import org.activiti.engine.impl.pvm.process.ActivityImpl;
import org.apache.commons.lang3.StringEscapeUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-05-08
 */
@Service
@Slf4j
public class WorkTemplateServiceImpl extends ServiceImpl<WorkTemplateMapper, TemplateDO> implements IWorkTemplateService {

    private Logger logger = LoggerFactory.getLogger(WorkTemplateServiceImpl.class);

    @Autowired
    private ReadBpmn readBpmn;
    @Autowired
    private ProcessEngine processEngine;

    @Autowired
    private ProcessFileMapper processFileMapper;

    @Autowired
    private WorkTemplateMapper workTemplateMapper;
    @Autowired
    private ProcessGatewayHiMapper processGatewayHiMapper;

    @Autowired
    private WorkApproveHiMapper workApproveHiMapper;
  /*  @Autowired
    private ProcessFileMapper processFileMapper;

    @Autowired
    private RepositoryService repositoryService;*/

    @Autowired
    private WorkApproveMapper workApproveMapper;

    @Autowired
    private WorkTypeMapper workTypeMapper;

    @Autowired
    private ProcessGatewayMapper processGatewayMapper;

    @Autowired
    private WorkPermissionHiMapper workPermissionHiMapper;
    /*  @Autowired
      private TbUserMapper tbUserMapper;*/
    @Autowired
    private WorkflowTemplateHiRepository workflowTemplateHiRepository;

    @Autowired
    private TbRoleMapper tbRoleMapper;

    @Autowired
    private WorkApproveServiceImpl workApproveService;

    @Autowired
    private IWorkTemplateService workTemplateService;

    @Autowired
    private IWorkTemplateFieldService workTemplateFieldService;

    @Autowired
    private IProcessFileService iProcessFileService;

    @Autowired
    private IWorkPermissionService workPermissionService;

    @Autowired
    private IWorkTemplateOtherSettingsService workTemplateOtherSettingsService;

    @Autowired
    private WorkflowTaskService workflowTaskService;
  /*  @Autowired
    private ProcessGatewayMapper processGatewayMapper;

    @Autowired
    private WorkBaseMapper workBaseMapper;*/

    @Autowired
    private IProcessGatewayService processGatewayService;

    @Autowired
    private WorkflowTaskHiRepository workflowTaskHiRepository;

    /*  @Autowired
      private TaskServiceImpl taskServiceImpl;
  */
  /*  @Autowired
    private TaskService taskService;

    @Autowired
    private ITaskDataService taskDataService;

    @Autowired
    private ITaskInfoService taskInfoService;

    @Autowired
    private IWorkRecordsService workRecordsService;

    @Autowired
    private WorkflowApproveDataMapper workflowApproveDataMapper;

    @Autowired
    private ITaskReadService taskReadService;*/
    @Autowired
    private WorkflowTaskHiService workflowTaskHiService;

    @Autowired
    private SRoleMapper sRoleMapper;

    @Autowired
    private WorkflowTemplateFormFieldHiRepository workflowTemplateFormFieldHiRepository;

    @Autowired
    private WorkflowTaskRepository workflowTaskRepository;

    @Autowired
    private WorkPermissionMapper workPermissionMapper;


    @Autowired
    private WorkPermissionMapper workApproveBytemplateFormFieldDO;

    @Autowired
    private RepositoryService repositoryService;

    @Value("${template.processfile.path}")
    private String processPath;

    private static final String TEMPLATE_ID = "template_id";

    private static final String XML_PATH = "xmlPath";

   /* @Override
    public Ret deployProcess(String templateId) {
        String checkResult = checkTemplate(templateId);
        if(!"SUCCESS".equals(checkResult)){
            return Ret.error().setMsg(checkResult);
        }
        try {
            QueryWrapper qw = new QueryWrapper();
            qw.eq(TEMPLATE_ID, templateId);
            List<TemplateProcessFileDO> list = processFileMapper.selectList(qw);
            if (list != null && list.size() == 1) {
                String processFile = list.get(0).getProcessFilePath();
                String processName = list.get(0).getProcessFileNm();
                //部署前把表达式写入到xml文件中
                //查询表达式
                QueryWrapper gerWayQw = new QueryWrapper<>();
                gerWayQw.eq(TEMPLATE_ID, templateId);
                List<TemplateGatewayDO> templateGatewayDOList = processGatewayMapper.selectList(gerWayQw);
                for (TemplateGatewayDO templateGatewayDO : templateGatewayDOList) {
                    boolean flagFlowId = addConditionExpression(processFile, templateGatewayDO.getActivityId(), templateGatewayDO.getConditions());
                    if (!flagFlowId) {
                        return Ret.error().setMsg("流程部署失败");
                    }
                }
                repositoryService.createDeployment()
                        .name(UUID.randomUUID().toString()).addInputStream(processName, new FileInputStream(new File(processFile))).deploy();
                TemplateProcessFileDO pf = new TemplateProcessFileDO();
                pf.setIfDeploy("1");
                QueryWrapper updateQw = new QueryWrapper();
                updateQw.eq(TEMPLATE_ID, templateId);
                int a = processFileMapper.update(pf, updateQw);
                if (a > 0) {
                    //启用模板
                    TemplateDO templateDO = new TemplateDO();
                    templateDO.setId(templateId);
                    templateDO.setIfEnable("1");
                    QueryWrapper<TemplateDO> qw2 = new QueryWrapper<>();
                    qw2.eq("id", templateId);
                    workTemplateService.update(templateDO, qw2);
                    return Ret.ok().setMsg("流程部署成功");
                }
            }
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        return Ret.error().setMsg("流程部署失败");
    }
*/

    /**
     * 模板校验
     * 校验规则：1.开始节点、所有用户任务节点必须配置表单项
     * 2.所有用户任务节点必须进行审批设置
     *
     * @return
     */
    private String checkTemplate(String templateId) {

        return "SUCCESS";
    }

    @Override
    public List<TemplateTypeResDTO> getAllTemplates(String ifEnable, String ifPhone) {
        List<TemplateTypeResDTO> result = new ArrayList<>();
        List<TemplateTypeDO> templateTypeDOList = workTypeMapper.selectList(null);
        for (TemplateTypeDO templateTypeDO : templateTypeDOList) {
            QueryWrapper qw = new QueryWrapper();
            qw.eq("work_tp_id", templateTypeDO.getId());
            if (StrUtil.isNotEmpty(ifPhone)) {
                qw.eq("PHONE", ifPhone);
            }
            if (StrUtil.isNotEmpty(ifEnable)) {
                qw.eq("IF_ENABLE", ifEnable);
            }
            qw.orderByDesc("CREATE_TIME");
            List<TemplateDO> templateList = baseMapper.selectList(qw);
            for (TemplateDO templateDO : templateList) {
                String[] strs = templateDO.getCreateRoles().split(",");
                List list = Arrays.asList(strs);
                List<SRole> tbRoles = sRoleMapper.selectBatchIds(list);
                String rolesName = "";
                for (SRole sRole : tbRoles) {
                    if (rolesName.equals("")) {
                        rolesName += sRole.getRoleName();
                    } else {
                        rolesName += "," + sRole.getRoleName();
                    }
                }
                templateDO.setCreateRoles(rolesName);
            }
            TemplateTypeResDTO templateTypeResDTO = new TemplateTypeResDTO();
            templateTypeResDTO.setTemplateList(templateList);
            templateTypeResDTO.setId(templateTypeDO.getId());
            templateTypeResDTO.setName(templateTypeDO.getName());
            templateTypeResDTO.setIfEnable(templateTypeDO.getIfEnable());
            result.add(templateTypeResDTO);
        }
        return result;
    }

    /*  */

    /**
     * 审批指定办理人
     * <p>
     * //@param templateId 模板id
     *//*
    @Override
    public boolean tsakAssignee(String templateId, List<Task> task2List, String workId,String userId) {
        try{
            for (Task task2 : task2List) {
                String activityId = task2.getTaskDefinitionKey();
                String taskId = task2.getId();

                //查询节点指定的用户
                TemplateApproveDO templateApproveDO = workApproveService.getApproveByTempIdAndactivityId(templateId, activityId);
                //设置办理人
                if (templateApproveDO != null) {
                    List<String> reveiverUsers = new ArrayList<>();
                    String personType = templateApproveDO.getPersonType();
                    if (TemplateApproveType.PERSON.getKey().equals(personType)) {
                        if(StrUtil.isEmpty(templateApproveDO.getPersonData())){
                            System.out.println("没有审批人");
                        }
                        String[] users = templateApproveDO.getPersonData().split(",");
                        for(int i=0;i<users.length;i++){
                            processEngine.getTaskService()//
                                    .addCandidateUser(taskId, users[i]);
                        }
                        reveiverUsers = Arrays.asList(users);
                    }
                    if (TemplateApproveType.ROLE.getKey().equals(personType)) {
                        //查询该角色对应的用户id
                        List<String> tbUserList = tbUserMapper.queryUserByRoleId(templateApproveDO.getPersonData().split(","));
                        for (String id : tbUserList) {
                            processEngine.getTaskService()//
                                    .addCandidateUser(taskId, id);
                        }
                        reveiverUsers = tbUserList;
                    }
                    if(TemplateApproveType.CREATESELECT.getKey().equals(personType) ||
                            TemplateApproveType.SUPERSELECT.getKey().equals(personType)){
                        QueryWrapper approveDataQw = new QueryWrapper();
                        approveDataQw.eq("work_id",workId);
                        approveDataQw.eq("activity_id",activityId);
                        TemplateApproveDataDO templateApproveDataDO = workflowApproveDataMapper.selectOne(approveDataQw);
                        if(templateApproveDataDO != null && templateApproveDataDO.getPersonData() != null){
                            processEngine.getTaskService()//
                                    .addCandidateUser(taskId, templateApproveDataDO.getPersonData());
                            reveiverUsers.add(templateApproveDataDO.getPersonData());
                        }
                    }
                    if(TemplateApproveType.CREATESELF.getKey().equals(personType)){
                        QueryWrapper qw = new QueryWrapper();
                        qw.eq("work_id",workId);
                        qw.eq("task_tp", TaskRecordType.CREATE.getKey());
                        List<TaskRecordsDO> TaskRecordsDO = workRecordsService.list(qw);
                        if(TaskRecordsDO != null && TaskRecordsDO.size() == 1){
                            processEngine.getTaskService()//
                                    .addCandidateUser(taskId, TaskRecordsDO.get(0).getHandlePerson());
                        }
                        reveiverUsers.add(TaskRecordsDO.get(0).getHandlePerson());
                    }
                    if(TemplateApproveType.SAMEBEFOR.getKey().equals(personType)){
                        processEngine.getTaskService()//
                                .addCandidateUser(taskId, userId);
                        reveiverUsers.add(userId);
                    }
                    //标记所有当前用户为任务未读状态
                    List<TaskReadDO> taskReadDOList = new ArrayList<>();
                    for(String user : reveiverUsers){
                        TaskReadDO taskReadDO =  TaskReadDO.builder().taskId(taskId).id(UUID.randomUUID().toString())
                                .userId(user).build();
                        taskReadDOList.add(taskReadDO);
                    }
                    taskReadService.saveBatch(taskReadDOList);

                    //给任务人发送消息
                    TaskDO taskDO = workBaseMapper.selectById(workId);
                    if(taskDO != null && "1".equals(taskDO.getIfSend())){
                        TaskInfoRDTO taskInfoRDTO = new TaskInfoRDTO();
                        taskInfoRDTO.setReveiverUsers(reveiverUsers);
                        taskInfoRDTO.setWorkId(workId);
                        taskInfoService.sendMessage(MessageType.NEWTASK.getKey(),taskInfoRDTO);
                    }
                }
            }
            return true;
        }catch(Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        return false;

    }*/

   /* @Transactional
    @Override
    public Boolean templateCopy(String templateId, String workTpId) {
        String templateIdNew = RandomUtil.randomString(9);
        //1.模板基础信息
        QueryWrapper<TemplateDO> qw = new QueryWrapper<>();
        qw.eq("id", templateId);
        TemplateDO templateDO = workTemplateService.getOne(qw);
        templateDO.setId(templateIdNew);
        templateDO.setTemplateNm(templateDO.getTemplateNm() + StringUtil.getRandomString(5));
        templateDO.setWorkTpId(workTpId);
        templateDO.setIfEnable("0");
        templateDO.setCreateTime(new Date());
        //复制模板基础信息
        workTemplateService.save(templateDO);

        //2.查询表单
        QueryWrapper qw1 = new QueryWrapper();
        qw1.eq(TEMPLATE_ID, templateId);
        qw1.orderByAsc("FIELD_ORDER");
        List<TemplateFormFieldDO> templateFormFieldDOList = workTemplateFieldService.list(qw1);
        for (TemplateFormFieldDO templateFormFieldDO : templateFormFieldDOList) {
            templateFormFieldDO.setId(templateFormFieldDO.getId() + RandomUtil.randomString(3));
            templateFormFieldDO.setTemplateId(templateIdNew);
        }
        workTemplateFieldService.saveBatch(templateFormFieldDOList);

        //3.查询流程文件xml
        Map<String, Object> activiti = new HashMap<>();
        //查询xml文件路径
        QueryWrapper qw3 = new QueryWrapper();
        qw3.eq(TEMPLATE_ID, templateId);
        TemplateProcessFileDO templateProcessFileDO = iProcessFileService.getOne(qw3);
        if (templateProcessFileDO != null) {
            //读取xml返回字符串
            FileReader fileReader = new FileReader(templateProcessFileDO.getProcessFilePath());
            String result = fileReader.readString();
            //替换processId
            result = result.replace("p" + templateId, "p" + templateIdNew);
            this.uploadActitytiBpmn(result, templateIdNew);
        }

        //表单权限配置
        QueryWrapper qw4 = new QueryWrapper<>();
        qw4.eq(TEMPLATE_ID, templateId);
        List<TemplatePermissionDO> templatePermissionDOList = workPermissionService.list(qw4);
        for (TemplatePermissionDO templatePermissionDO : templatePermissionDOList) {
            templatePermissionDO.setId(IdUtil.randomUUID());
            templatePermissionDO.setTemplateId(templateIdNew);
        }
        workPermissionService.saveBatch(templatePermissionDOList);

        // 流程判断
        QueryWrapper processGatewayQueryWrapper = new QueryWrapper<>();
        processGatewayQueryWrapper.eq(TEMPLATE_ID, templateId);
        List<TemplateGatewayDO> templateGatewayDOList = processGatewayService.list(processGatewayQueryWrapper);
        for(TemplateGatewayDO templateGatewayDO : templateGatewayDOList) {
            templateGatewayDO.setId(IdUtil.randomUUID());
            templateGatewayDO.setTemplateId(templateIdNew);
        }
        processGatewayService.saveBatch(templateGatewayDOList);

        //审批人员配置
        List<TemplateApproveDO> templateApproveDOList = workApproveService.getWorkApprove(templateId);
        for (TemplateApproveDO templateApproveDO : templateApproveDOList) {
            templateApproveDO.setTemplateId(templateIdNew);
            templateApproveDO.setId(IdUtil.randomUUID());
        }
        workApproveService.saveBatch(templateApproveDOList);

        //4.查询其他设置
        QueryWrapper<TemplateOtherSettingsDO> qw5 = new QueryWrapper<>();
        qw5.eq(TEMPLATE_ID, templateId);
        TemplateOtherSettingsDO templateOtherSettingsDO = workTemplateOtherSettingsService.getOne(qw5);
        if (templateOtherSettingsDO != null) {
            templateOtherSettingsDO.setTemplateId(templateIdNew);
            workTemplateOtherSettingsService.save(templateOtherSettingsDO);
        }
        return true;
    }*/
    @Override
    @Transactional
    public Boolean publishBytemplate(TemplateDO templateDO) {
        try {
            //通过原来template查询file地址
            QueryWrapper<TemplateProcessFileDO> qw1 = new QueryWrapper<>();
            qw1.eq("template_id", templateDO.getId());
            List<TemplateProcessFileDO> templateProcessFileDOS = processFileMapper.selectList(qw1);
            String processFilePath = templateProcessFileDOS.get(0).getProcessFilePath();
            List<String> activitiIds = new ArrayList<>();
            if (processFilePath != null) {
                activitiIds = readBpmn.newProcessFile(processFilePath, templateDO.getId());
            }
            //删除activitiIds不存在的审批人和权限
            workPermissionMapper.deleteByActivitiId(activitiIds,templateDO.getId());
            workApproveMapper.deleteByActivitiId(activitiIds,templateDO.getId());
            //根据模板id查询工单表数据
            WorkflowTask workflowTask = workflowTaskService.selectBytemplate(templateDO);
            if (workflowTask != null) {
                //修改工单状态为发布
                workflowTaskRepository.updateStatus(templateDO);
                //重新生成workId
                workflowTask.setWorkId(String.valueOf(UUID.randomUUID()));
                //数据存入工单存贮表
                workflowTaskHiRepository.insertWorkflowTaskHi(workflowTask);
            }
            //修改模板状态
            workTemplateMapper.updateStatus(templateDO);
            //根据模板id查出模板数据
            QueryWrapper<TemplateDO> qw = new QueryWrapper<>();
            qw.eq("id", templateDO.getId());
            TemplateDO templateDO1 = workTemplateService.getOne(qw);
            WorkflowTemplateHi workflowTemplateHi = new WorkflowTemplateHi();
            //根据模板类型查询历史模板表最大版本
            List<String> versionHiByTptem = workflowTemplateHiRepository.temVersionHiByTptem(templateDO1);
            //判断是否存在
            if (StringUtils.isNotEmpty(versionHiByTptem.get(0))) {
                //存在版本加1
                String version = String.valueOf(Integer.parseInt(versionHiByTptem.get(0)) + 1);
                workflowTemplateHi.setVersion(version);
            } else {
                //不存在默认版本为1
                String version = "1";
                workflowTemplateHi.setVersion(version);
            }
            //重新生成模板
            workflowTemplateHi.setId(String.valueOf(UUID.randomUUID()));
            workflowTemplateHi.setCreateRoles(templateDO1.getCreateRoles());
            workflowTemplateHi.setCreateTime(templateDO1.getCreateTime());
            workflowTemplateHi.setIconImage(templateDO1.getIconImage());
            workflowTemplateHi.setIfEnable(templateDO1.getIfEnable());
            workflowTemplateHi.setManagerRoles(templateDO1.getManagerRoles());
            workflowTemplateHi.setPhone(templateDO1.getPhone());
            workflowTemplateHi.setTemplateExplain(templateDO1.getWorkTpId());
            workflowTemplateHi.setTemplateNm(templateDO1.getTemplateNm());
            workflowTemplateHi.setTypeTemplate(templateDO1.getTypeTemplate());
            workflowTemplateHi.setUpdateTime(templateDO1.getUpdateTime());
            workflowTemplateHi.setWorkTpId(templateDO1.getWorkTpId());
            //保存到模板存贮表
            workflowTemplateHiRepository.insertTemplateHi(workflowTemplateHi);
            //根据当前模板id对应的Field
            List<TemplateFormFieldDO> templateFormFieldDOS = workTemplateFieldService.selectWorkTempldateField(templateDO.getId());
            List<TemplateFormFieldDO> templateFormFieldHiDOS = new ArrayList<>();
            List<TemplatePermissionDO> templatePermissionDOHis = new ArrayList<>();
            for (TemplateFormFieldDO templateFormFieldDO : templateFormFieldDOS) {
                //根据原来的模板id和原fieldid和活动id找到当前的permission对象
                List<TemplatePermissionDO> templatePermissionDOs = workPermissionMapper.workPermissionByTemplateFormFieldDO(templateFormFieldDO);
                //重新生成Formfield的ID
                templateFormFieldDO.setId(String.valueOf(UUID.randomUUID()));
                //设置模板id为对应的模板存贮表id；
                templateFormFieldDO.setTemplateId(workflowTemplateHi.getId());
                for (TemplatePermissionDO templatePermissionDO : templatePermissionDOs) {
                        //重新生成权限表id
                        templatePermissionDO.setId(String.valueOf(UUID.randomUUID()));
                        //设置权限表表单id为表单存贮表当前id
                        templatePermissionDO.setFieldId(templateFormFieldDO.getId());
                        //设置模板id为对应的模板存贮表id；
                        templatePermissionDO.setTemplateId(workflowTemplateHi.getId());
                        //历史权限表数据存入list
                        templatePermissionDOHis.add(templatePermissionDO);
                }

                //历史表单数据存入list
                templateFormFieldHiDOS.add(templateFormFieldDO);
            }
            //查询当前原模板id对应的GateWay
            QueryWrapper wrapper1 = new QueryWrapper();
            wrapper1.eq("template_id", templateDO.getId());
            List<TemplateGatewayDO> templateGatewayDOs = processGatewayMapper.selectList(wrapper1);
            List<TemplateGatewayDO> templateGatewayHis = new ArrayList<>();
            for (TemplateGatewayDO templateGatewayDO : templateGatewayDOs) {
                templateGatewayDO.setId(String.valueOf(UUID.randomUUID()));
                templateGatewayDO.setTemplateId(workflowTemplateHi.getId());
                templateGatewayHis.add(templateGatewayDO);

            }
            //保存到Gateway存贮表
            if (templateGatewayHis.size() > 0) {
                processGatewayHiMapper.insertGatewayHi(templateGatewayHis);
            }
            //保存到Permisstion存贮表
            if (templatePermissionDOHis.size() > 0) {
                workPermissionHiMapper.insertPermissionHi(templatePermissionDOHis);
            }//保存到FormField存贮表
            if (templateFormFieldHiDOS.size() > 0) {
                workflowTemplateFormFieldHiRepository.insertFormFieldHi(templateFormFieldHiDOS);
            }
            //查询当前原模板id对应的approve
            QueryWrapper wrapper = new QueryWrapper();
            wrapper.eq("template_id", templateDO.getId());
            List<TemplateApproveDO> TemplateApproveDOlist = workApproveMapper.selectList(wrapper);
            List<TemplateApproveDO> TemplateApproveDOHis = new ArrayList<>();
            for (TemplateApproveDO templateApproveDO : TemplateApproveDOlist) {
                    templateApproveDO.setId(String.valueOf(UUID.randomUUID()));
                    templateApproveDO.setTemplateId(workflowTemplateHi.getId());
                    TemplateApproveDOHis.add(templateApproveDO);

            }
            //保存当approve存储表
            if (TemplateApproveDOHis.size() > 0) {
                workApproveHiMapper.insertApproveHi(TemplateApproveDOHis);
            }
            //保存到网关历史表

            return true;
        } catch (Exception e) {
            logger.error(e.getMessage());
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
        }
        return false;
    }

    ;

    //@Transactional
    @Override
    public Ret saveTemplateAll(WorkTemplateResDTO workTemplateResDTO) {
        if (StrUtil.isEmpty(workTemplateResDTO.getTemplateId())) {
            return Ret.error().setMsg("模板id不能为空");
        }
        String templateId = workTemplateResDTO.getTemplateId();
        //任务基础设置-----------------------------------------------------------------------
        //1保存基础信息
        if (workTemplateResDTO.getWorkTemplate() != null) {
            //判断模板id是否存在
            TemplateDO templateDO = workTemplateService.getById(templateId);
            workTemplateResDTO.getWorkTemplate().setId(templateId);
            if (templateDO != null) {
                workTemplateResDTO.getWorkTemplate().setUpdateTime(new Date());
                workTemplateResDTO.getWorkTemplate().setStatus("0");
                workTemplateService.updateById(workTemplateResDTO.getWorkTemplate());
            } else {
                workTemplateResDTO.getWorkTemplate().setIfEnable("0");
                workTemplateResDTO.getWorkTemplate().setCreateTime(new Date());
                workTemplateService.save(workTemplateResDTO.getWorkTemplate());
            }
        }
        //任务基础设置-----------------------------------------------------------------------------
        //2保存表单信息
        if (StrUtil.isNotEmpty(workTemplateResDTO.getFieldJsonStr())) {
            workTemplateFieldService.saveOrUpdateWorkTempldateField(templateId, workTemplateResDTO.getFieldJsonStr());
        } else if (workTemplateResDTO.getFieldJsonStr() == "") {
            workTemplateFieldService.deleteWorkTempldateField(templateId);
        }

        //3保存流程文件
        if (StrUtil.isNotEmpty(workTemplateResDTO.getXmlJson())) {
            this.uploadActitytiBpmn(workTemplateResDTO.getXmlJson(), templateId);
        }
        //任务其他设置----------------------------------------------------------------------
        //审批人员配置
        if (workTemplateResDTO.getWorkApproveList() != null && !workTemplateResDTO.getWorkApproveList().isEmpty()) {
            workApproveService.saveWorkApproveBatch(workTemplateResDTO.getWorkApproveList());
        }
        //任务其他设置---------------------------------------------------------------------
        //表单权限配置
        if (StrUtil.isNotEmpty(workTemplateResDTO.getPermissionJson())) {
            workPermissionService.saveWorkPermissionBatch(workTemplateResDTO.getPermissionJson());
        }
        //保存表达式
        if (workTemplateResDTO.getProcessGatewayList() != null && !workTemplateResDTO.getProcessGatewayList().isEmpty()) {
            //先进行删除
            QueryWrapper qw = new QueryWrapper();
            qw.eq("template_id", templateId);
            processGatewayService.remove(qw);
            for (TemplateGatewayDO templateGatewayDO : workTemplateResDTO.getProcessGatewayList()) {
                templateGatewayDO.setId(IdUtil.randomUUID());
            }
            processGatewayService.saveBatch(workTemplateResDTO.getProcessGatewayList());
        }

        //任务其他设置？？----------------------------------------------------------------
        //4保存其他设置
       /* if (workTemplateResDTO.getWorkTemplateOtherSettings() != null) {
            QueryWrapper qw5 = new QueryWrapper();
            qw5.eq(TEMPLATE_ID, templateId);
            workTemplateOtherSettingsService.remove(qw5);
            workTemplateOtherSettingsService.save(workTemplateResDTO.getWorkTemplateOtherSettings());
        }*/
        //任务其他设置？？----------------------------------------------------------------
        return Ret.ok().setMsg("保存成功");
    }

    /*  @Override
      public Boolean saveTemplateService(TemplateDO templateDO) {
          String tempId = IdUtil.randomUUID();
          templateDO.setId(tempId);
          templateDO.setIfEnable("0");
          return workTemplateService.save(templateDO);
      }

      @Override
      public List<TemplateDO> getTemplateList(TemplateDO templateDO) {
          QueryWrapper<TemplateDO> qw = new QueryWrapper<>();
          if (StringUtils.isNotEmpty(templateDO.getId())) {
              qw.eq("id", templateDO.getId());
          }
          if (StringUtils.isNotEmpty(templateDO.getIfEnable())) {
              qw.eq("IF_ENABLE", templateDO.getIfEnable());
          }
          if (StringUtils.isNotEmpty(templateDO.getPhone())) {
              qw.eq("PHONE", templateDO.getPhone());
          }
          if (StringUtils.isNotEmpty(templateDO.getTemplateNm())) {
              qw.like("TEMPLATE_NM", templateDO.getTemplateNm());
          }
          if (StringUtils.isNotEmpty(templateDO.getWorkTpId())) {
              qw.like("WORK_TP_ID", templateDO.getWorkTpId());
          }
          return workTemplateService.list(qw);
      }

      @Override
      public IPage<TemplateDO> getTemplatePage(TemplateDO templateDO, Integer page, Integer size) {
          QueryWrapper<TemplateDO> qw = new QueryWrapper<>();
          if (StringUtils.isNotEmpty(templateDO.getId())) {
              qw.eq("id", templateDO.getId());
          }
          if (StringUtils.isNotEmpty(templateDO.getIfEnable())) {
              qw.eq("IF_ENABLE", templateDO.getIfEnable());
          }
          if (StringUtils.isNotEmpty(templateDO.getPhone())) {
              qw.eq("PHONE", templateDO.getPhone());
          }
          if (StringUtils.isNotEmpty(templateDO.getTemplateNm())) {
              qw.like("TEMPLATE_NM", templateDO.getTemplateNm());
          }
          if (StringUtils.isNotEmpty(templateDO.getWorkTpId())) {
              qw.eq("WORK_TP_ID", templateDO.getWorkTpId());
          }
          return workTemplateService.page(new Page<>(page, size), qw);
      }
  */
    @Override
    public WorkTemplateResDTO getTemplateByTemplateId(String templateId) {
        WorkTemplateResDTO workTemplateResDTO = new WorkTemplateResDTO();
        //1.模板基础信息
        QueryWrapper<TemplateDO> qw = new QueryWrapper<>();
        qw.eq("id", templateId);
        TemplateDO templateDO = workTemplateService.getOne(qw);
        workTemplateResDTO.setWorkTemplate(templateDO);
        //2.查询表单
        QueryWrapper qw1 = new QueryWrapper();
        qw1.eq(TEMPLATE_ID, templateId);
        qw1.orderByAsc("FIELD_ORDER");
        List<TemplateFormFieldDO> templateFormFieldDOList = workTemplateFieldService.list(qw1);
        workTemplateResDTO.setTemplateFormFieldList(templateFormFieldDOList);
        //3.查询流程文件xml
        ActivitiResDTO activiti = new ActivitiResDTO();
        //查询xml文件路径
        QueryWrapper qw2 = new QueryWrapper();
        qw2.eq(TEMPLATE_ID, templateId);
        List<TemplateProcessFileDO> processFile = iProcessFileService.list(qw2);
        if (processFile != null && !processFile.isEmpty()) {
            //读取xml返回字符串
            FileReader fileReader = new FileReader(processPath + processFile.get(0).getProcessFilePath());
            String result = fileReader.readString();
            activiti.setXmlPath(result);
        }
        List<WorkPermissionInfoResDTO> workPermission = workPermissionService.getWorkPermissionByTemplateId(templateId);
        activiti.setWorkPermission(workPermission);
        List<TemplateApproveDO> templateApproveDOList = workApproveService.getWorkApprove(templateId);

        activiti.setWorkApproveList(templateApproveDOList);
        QueryWrapper qw6 = new QueryWrapper();
        qw6.eq(TEMPLATE_ID, templateId);
        List<TemplateGatewayDO> processGatewayList = processGatewayService.list(qw6);

        Map<String, TemplateFormFieldDO> templateFormFieldDOMap = new HashMap<>(templateFormFieldDOList.size());
        for (TemplateFormFieldDO templateFormFieldDO : templateFormFieldDOList) {
            templateFormFieldDOMap.put(templateFormFieldDO.getId(), templateFormFieldDO);
        }
        for (TemplateGatewayDO templateGatewayDO : processGatewayList) {
            templateGatewayDO.setTemplateFormFieldDO(templateFormFieldDOMap.get(templateGatewayDO.getFieldId()));
        }
        activiti.setProcessGatewayList(processGatewayList);
        workTemplateResDTO.setActivitiml(activiti);
      /*  //4.查询其他设置
        QueryWrapper<TemplateOtherSettingsDO> qw3 = new QueryWrapper<>();
        qw3.eq(TEMPLATE_ID, templateId);
        TemplateOtherSettingsDO templateOtherSettingsDO = workTemplateOtherSettingsService.getOne(qw3);
        workTemplateResDTO.setWorkTemplateOtherSettings(templateOtherSettingsDO);*/
        return workTemplateResDTO;
    }
 /*
    @Override
    public Boolean updateTemplateMove(String templateId, String workTpId) {
        TemplateDO templateDO = new TemplateDO();
        templateDO.setId(templateId);
        templateDO.setWorkTpId(workTpId);
        return workTemplateService.updateById(templateDO);
    }*/

   /* @Override
    public boolean completTeask(TaskInfoRDTO taskInfoRDTO) {
        try{
            taskInfoService.completeTaskBefor(taskInfoRDTO);

            String taskId = taskInfoRDTO.getTaskId();
            String isAgree = taskInfoRDTO.getIsAgree();
            String workId = taskInfoRDTO.getWorkId();

            TaskEntity task = (TaskEntity) taskService.createTaskQuery().taskId(taskId).singleResult();

            //完成任务
            this.taskService.addComment(taskId, task.getProcessInstanceId(), isAgree);
            //设置流程变量
            Map<String, Object> variables = new HashMap<>();
            //查询表单所有变量
            QueryWrapper qw = new QueryWrapper();
            qw.eq("WORK_ID", workId);
            List<TaskDataDO> taskDataList = taskDataService.list(qw);
            for (TaskDataDO taskData : taskDataList) {
                variables.put(taskData.getFieldId(), taskData.getFieldValue());
            }
            if (StrUtil.isNotEmpty(isAgree)) {
                variables.put("flag", isAgree);
            }
            this.processEngine.getTaskService().complete(taskId, variables);
            //创建查询对象
            List<Task> task2List = taskService.createTaskQuery()
                    .processInstanceId(task.getProcessInstanceId()).list();

            //任务完成回调
            taskInfoService.completeTaskCallback(task2List,workId,taskInfoRDTO);
            return true;
        }catch(Exception e){
            logger.error(e.getMessage());
            e.printStackTrace();
        }
        return false;
    }

    @Override
    public boolean completTaskBatch(List<TaskInfoRDTO> taskInfoRDTOList) {
        if(taskInfoRDTOList != null){
            for(TaskInfoRDTO taskInfoRDTO : taskInfoRDTOList){
                completTeask(taskInfoRDTO);
            }
        }
        return true;
    }*/

   /* @Override
    public boolean recall(String processId, String activityId) {
        //不能撤回的情况1.判断是否是自己提交的2.判断流程是否已结束3.下一级是否已审批

        //查询当前节点
        Task task = taskService.createTaskQuery()
                .processInstanceId(processId)
                .singleResult();

        if (task == null) {
            return false;
        }
        Map<String, Object> vars = new HashMap<>();
        // 目标节点
        ActivityImpl destinationActivity = queryTargetActivity(activityId, task.getProcessDefinitionId());
        // 当前节点实例id
        String executionId = task.getExecutionId();
        // 当前节点
        ActivityImpl currentActivity = queryTargetActivity(task.getTaskDefinitionKey(), task.getProcessDefinitionId());

        CommandExecutor commandExecutor = taskServiceImpl
                .getCommandExecutor();
        commandExecutor.execute(new JDJumpTaskCmd(executionId, destinationActivity, vars, currentActivity));
        return true;
    }*/

    /*@Transactional
    @Override
    public boolean removeTemplate(String id) {
        //1.删除模板表
        if(baseMapper.deleteById(id) !=1){
            return false;
        }
        QueryWrapper qw1 = new QueryWrapper();
        qw1.eq(TEMPLATE_ID, id);

        if(!workTemplateFieldService.remove(qw1)){
            return false;
        }

        if(!iProcessFileService.remove(qw1)){
            return false;
        }

        if(!workPermissionService.remove(qw1)){
            return false;
        }

        if(!workApproveService.remove(qw1)){
            return false;
        }

        if(!processGatewayService.remove(qw1)){
            return false;
        }

        if(!workTemplateOtherSettingsService.remove(qw1)){
            return false;
        }
        return true;
    }*/

    /**
     * 根据ActivityId 查询出来想要活动Activity
     *
     * @param id
     * @return
     */
    private ActivityImpl queryTargetActivity(String id, String processDefinitionId) {
        ReadOnlyProcessDefinition deployedProcessDefinition = ((RepositoryServiceImpl) processEngine.getRepositoryService())
                .getDeployedProcessDefinition(processDefinitionId);
        List<ActivityImpl> activities = (List<ActivityImpl>) deployedProcessDefinition.getActivities();
        for (ActivityImpl activityImpl : activities) {
            if (activityImpl.getId().equals(id)) {
                return activityImpl;
            }
        }
        return null;
    }

    /**
     * 上传工作流文件base64
     *
     * @param xmlJson
     * @param tempId
     * @return
     */
    private Boolean uploadActitytiBpmn(String xmlJson, String tempId) {
        String xml = StringEscapeUtils.unescapeJava(xmlJson);
        xml = xml.replace("bpmn2:", "");
        xml = xml.replace(":bpmn2", "");
        String path = processPath;

        String fileName = processFileMapper.fileNameBytemplateId(tempId);
        if (fileName == null || "".equals(fileName)) {
            fileName = IdUtil.randomUUID() + ".bpmn";
        }
        FileWriter writer = new FileWriter(fileName);
        writer.write(xml);
        File file = writer.getFile();
        if (!FileUtil.isEmpty(file)) {
            try {
                File filepath = new File(path);
                if (!filepath.exists()) {
                    filepath.mkdirs();
                }
                // 文件保存路径
                String savePath = path + fileName;
                // 转存文件
                FileUtil.copy(file, new File(savePath), true);
                return iProcessFileService.uploadProcessFileByFileName(fileName, tempId, processPath);
            } catch (Exception e) {
                logger.error("文件保存错误");
            }
        }
        return false;
    }

    /**
     * 根据流程文件获取流程文件的唯一ID
     *
     * @param processFile
     * @return
     */
    private String queryBPMNkeyByFile(File processFile) {
        XMLInputFactory xif = XMLInputFactory.newInstance();
        //InputStreamReader in;
        XMLStreamReader xtr;
        String activitiNodeId = "";
        try (InputStreamReader in = new InputStreamReader(new FileInputStream(processFile))) {
            xtr = xif.createXMLStreamReader(in);
            BpmnModel model = new BpmnXMLConverter().convertToBpmnModel(xtr);
            if (model != null) {
                List<FlowElement> flowElements = (List) model.getMainProcess().getFlowElements();
                activitiNodeId = flowElements.get(0).getId();
            }
        } catch (Exception e) {
            logger.error("文件读取错误");
        }
        return activitiNodeId;
    }
}
