package com.zgiot.zx.workflow.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zgiot.zx.workflow.dto.TemplateTypeResDTO;
import com.zgiot.zx.workflow.dto.WorkTemplateResDTO;
import com.zgiot.zx.workflow.entity.*;
import com.zgiot.zx.workflow.mapper.*;
import com.zgiot.zx.workflow.service.IWorkTemplateFieldService;
import com.zgiot.zx.workflow.service.IWorkTemplateService;
import com.zgiot.zx.workflow.service.WorkflowTaskService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 15:50  2019/7/29
 * @Modified By:
 */
@Service
public class WorkflowTaskServiceImpl extends ServiceImpl<WorkflowTaskRepository, WorkflowTask> implements WorkflowTaskService {
    private Logger logger = LoggerFactory.getLogger(WorkflowTaskServiceImpl.class);
    @Autowired
    private WorkTypeMapper workTypeMapper;
    @Autowired
    private TbRoleMapper tbRoleMapper;

    public List<TemplateTypeResDTO> getAllWorkflowTask() {
        List<TemplateTypeResDTO> result = new ArrayList<>();
        List<TemplateTypeDO> templateTypeDOList = workTypeMapper.selectList(null);

        for (TemplateTypeDO templateTypeDO : templateTypeDOList) {
            QueryWrapper qw = new QueryWrapper();
            qw.eq("work_tp_id", templateTypeDO.getId());
            qw.orderByDesc("create_time");
            List<WorkflowTask> workflowTaskList = baseMapper.selectList(qw);
            TemplateTypeResDTO templateTypeResDTO = new TemplateTypeResDTO();
            templateTypeResDTO.setWorkflowTaskList(workflowTaskList);
            templateTypeResDTO.setId(templateTypeDO.getId());
            templateTypeResDTO.setName(templateTypeDO.getName());
            templateTypeResDTO.setIfEnable(templateTypeDO.getIfEnable());
            result.add(templateTypeResDTO);
        }
        return result;
    }

    ;

    //修改工单状态
    @Override
    public WorkflowTask updateWorkflowTask(WorkTemplateResDTO workTemplateResDTO) {

        return null;
    }

    @Override
    public WorkflowTask selectBytemplate(TemplateDO templateDO) {
        QueryWrapper qw = new QueryWrapper();
        qw.eq("template_id", templateDO.getId());
        WorkflowTask workflowTask = baseMapper.selectOne(qw);
        return workflowTask;
    }
}
