package com.zgiot.zx.workflow.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zgiot.zx.workflow.base.Ret;
import com.zgiot.zx.workflow.dto.*;
import com.zgiot.zx.workflow.entity.SDept;
import com.zgiot.zx.workflow.entity.SRole;
import com.zgiot.zx.workflow.entity.SUser;
import com.zgiot.zx.workflow.mapper.SDeptMapper;
import com.zgiot.zx.workflow.mapper.SRoleMapper;
import com.zgiot.zx.workflow.mapper.SUserMapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author David
 */
@Slf4j
@Component
public class MTCotactApiRequestClient {


    private static final Logger logger = LoggerFactory.getLogger(MTCotactApiRequestClient.class);

    public static String ACCESS_TOKEN = "eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9.eyJjcmVkZW50aWFsc05vbkV4cGlyZWQiOnRydWUsImFjY291bnROb25FeHBpcmVkIjp0cnVlLCJleHAiOjE1NjA5MDEwNTQ0MDMsImF1dGhvcml0aWVzIjpbeyJhdXRob3JpdHkiOiJST0xFX0FDQ09VTlRfUk9MRSJ9XSwiZW5hYmxlZCI6dHJ1ZSwiYWNjb3VudE5vbkxvY2tlZCI6dHJ1ZSwidXNlcm5hbWUiOiIxMTM5NDQyNDc3MjA5ODIxMTg2In0.SC3A6A-GE9eylYMutr6lwHwdo7knwDZaIrsV8pSjZhE3Er2irVpH5G0MzeWezG_9Y1u-KsYaz2CNn_MNo7QMpUsQNqtf8efUbuviTcuqWwCa4jHL9T2rLUwnvkyQjRqtR5zup7HjROzh_tImHbOku3OHqGX-NHSKFMvdpZwPJ8c";

    @Autowired
    private SRoleMapper sRoleMapper;

    @Autowired
    private SDeptMapper sDeptMapper;

    @Autowired
    private SUserMapper sUserMapper;
    @Autowired
    private OkHttpUtil okHttpUtil;

    @Value("${mt.api}")
    private String api;

    /*  *//**
     * 根据accessToken获取当前用户信息
     *
     * @param accessToken
     * @return
     *//*
    public MTMyInfoRspDTO accountGetMyInfo(String accessToken) {
        login();
        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + ACCESS_TOKEN);
        String json = okHttpUtil.get(api + "contact/v1/account/get_my_info", null, headerParams);
        if(StringUtils.isNotEmpty(json)) {
            return JSON.parseObject(json, new TypeReference<Ret<MTMyInfoRspDTO>>() {}).getData();
        }
        return null;
    }*/

    /**
     * 角色组&角色列表查询
     *
     * @param corpId
     * @param accessToken
     * @return
     */
    public List<MTRoleGroupInfoRspDTO> roleListRoleGroup(String corpId, String accessToken) {
        List<MTRoleGroupInfoRspDTO> MTRoleGroupInfoRspDTOs = new ArrayList<>();
        MTRoleGroupInfoRspDTO mtRoleGroupInfoRspDTO = new MTRoleGroupInfoRspDTO();
        List<SRole> sRoles = sRoleMapper.querySRoles();
        MTRoleGroupInfoRspDTO.RolesBean rolesBean=null;
        List< MTRoleGroupInfoRspDTO.RolesBean> list = new ArrayList<>();
        for (SRole sRole: sRoles) {
            rolesBean =  new MTRoleGroupInfoRspDTO.RolesBean();
            rolesBean.setId(sRole.getBusinessId());
            rolesBean.setName(sRole.getRoleName());
            list.add(rolesBean);
        }
        mtRoleGroupInfoRspDTO.setId("11");
        mtRoleGroupInfoRspDTO.setName("role组名");
        mtRoleGroupInfoRspDTO.setCorpId("11");
        mtRoleGroupInfoRspDTO.setSRole(list);
        MTRoleGroupInfoRspDTOs.add(mtRoleGroupInfoRspDTO);
        return MTRoleGroupInfoRspDTOs;
    }

    ;
    /*
     *//**
     * 根据公司id和用户ids 获取用户信息
     *
     * @param MTUserGetsReqDTO
     * @param accessToken
     * @return
     *//*
    public List<MTUserInfoRspDTO> userGets(MTUserGetsReqDTO MTUserGetsReqDTO, String accessToken) {
        login();
        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + ACCESS_TOKEN);
        String json = okHttpUtil.postForJson(api + "contact/v1/user/gets", JSON.toJSONString(MTUserGetsReqDTO), headerParams);
        if(StringUtils.isNotEmpty(json)) {
            return JSON.parseObject(json, new TypeReference<Ret<List<MTUserInfoRspDTO>>>() {
            }).getData();
        }
        return new ArrayList<>();
    }*/

    /* *//**
     * 根据公司id和角色id 获取该角色下的所有人员
     *
     * @param corpId
     * @param roleId
     * @param accessToken
     * @return
     *//*
    public List<MTRoleUserInfoRspDTO> userGetRoleInfoList(String corpId, String roleId, String accessToken) {
        login();
        Map<String, String> queries = new HashMap<>(1);
        queries.put("corpId", "6");
        queries.put("roleId", "1128488322302513154");

        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + ACCESS_TOKEN);
        String json = okHttpUtil.get(api + "contact/v1/user/getRoleInfoList", queries, headerParams);
        if(StringUtils.isNotEmpty(json)) {
            return JSON.parseObject(json, new TypeReference<Ret<List<MTRoleUserInfoRspDTO>>>() {
            }).getData();
        }
        return new ArrayList<>();
    }*/

    /**
     * 根据公司获取公司下的所有部门(tree)
     *
     * @param corpId
     * @param accessToken
     * @return
     */
    public MTDeptTreeUserInfoRspDTO deptGetTreeByCorpId(String corpId, String accessToken) {
        MTDeptTreeUserInfoRspDTO mtDeptTreeUserInfoRspDTO = new MTDeptTreeUserInfoRspDTO();
       /* List<SDept> sDepts = sDeptMapper.querySDepts();
        if (sDepts.size()<1)
            return mtDeptTreeUserInfoRspDTO;*/
        SDept sDept = new SDept();
        sDept.setBusinessId("0");
        /*mtDeptTreeUserInfoRspDTO.setDeptId(sDept.getBusinessId());
        mtDeptTreeUserInfoRspDTO.setDeptName(sDept.getName());*/
       /* mtDeptTreeUserInfoRspDTO.setsDept(sDept);
        List<SUser> sUsers = sUserMapper.querySUsers(sDept);

        MTDeptTreeUserInfoRspDTO.UserInfo userinfo = null;
        List<MTDeptTreeUserInfoRspDTO.UserInfo> list = new ArrayList<>();
        if (sUsers.size()>0) {
            for (SUser sUser : sUsers) {
                userinfo = new MTDeptTreeUserInfoRspDTO().new UserInfo();
                userinfo.setId(sUser.getBusinessId());
                userinfo.setName(sUser.getName());
                list.add(userinfo);
            }
        }
        mtDeptTreeUserInfoRspDTO.setUserInfoList(list);*/
        mtDeptTreeUserInfoRspDTO.setsDept(sDept);
        //children
        childGetTree(mtDeptTreeUserInfoRspDTO);
        return mtDeptTreeUserInfoRspDTO;

    }

    public void childGetTree(MTDeptTreeUserInfoRspDTO mtDeptTreeUserInfoRspDTO) {
        List<SDept> childdept = sDeptMapper.childdept(mtDeptTreeUserInfoRspDTO.getsDept());
        if (CollectionUtils.isEmpty(childdept)) {
            return;
        }
        for (SDept se : childdept) {
            MTDeptTreeUserInfoRspDTO mt = new MTDeptTreeUserInfoRspDTO();
            List<SUser> sUsers = sUserMapper.querySUsers(se);
            mt.setDeptId(se.getBusinessId());
            mt.setDeptName(se.getName());
            mt.setsDept(se);
           // mt.setsUsers(sUsers);
            MTDeptTreeUserInfoRspDTO.UserInfo userinfo = null;
            List<MTDeptTreeUserInfoRspDTO.UserInfo> listUserInfo = new ArrayList<>();
            for (SUser sUser: sUsers) {
                userinfo = new MTDeptTreeUserInfoRspDTO().new UserInfo();
                userinfo.setId(sUser.getBusinessId());
                userinfo.setName(sUser.getName());
                listUserInfo.add(userinfo);
            }
            mt.setUserInfoList(listUserInfo);
            if (CollectionUtils.isEmpty(mtDeptTreeUserInfoRspDTO.getChildDeptTreeResDTOS())) {
                List<MTDeptTreeUserInfoRspDTO> list = new ArrayList<>();
                list.add(mt);
                mtDeptTreeUserInfoRspDTO.setChildDeptTreeResDTOS(list);
            } else {
                mtDeptTreeUserInfoRspDTO.getChildDeptTreeResDTOS().add(mt);
            }
            this.childGetTree(mt);
        }
    }

    /* *//**
     * 根据公司id和部门ids获取用户列表
     * @param corpId
     * @param deptIds
     * @param accessToken
     * @return
     *//*
    public List<MTGetUserByDeptIdsRspDTO> userGetUserByDeptIds(String corpId, List<String> deptIds, String accessToken) {
        login();
        MTGetUserByDeptIdsReqDTO mtGetUserByDeptIdsReqDTO = new MTGetUserByDeptIdsReqDTO();

        mtGetUserByDeptIdsReqDTO.setCorpId(corpId);
        mtGetUserByDeptIdsReqDTO.setDeptIds(deptIds);

        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + ACCESS_TOKEN);
        String json = okHttpUtil.postForJson(api + "contact/v1/user/get_user_by_deptids", JSON.toJSONString(mtGetUserByDeptIdsReqDTO), headerParams);
        if(StringUtils.isNotEmpty(json)) {
            return JSON.parseObject(json, new TypeReference<Ret<List<MTGetUserByDeptIdsRspDTO>>>() {
            }).getData();
        }
        return new ArrayList<>();
    }*/

    /* *//**
     * 获取某个部门的下级部门和人员
     * @param corpId
     * @param pid
     * @param accessToken
     * @return
     *//*
    public MTDeptSubDeptUserPagelistRspDTO deptSubDeptUserPagelist(String corpId, String pid, String accessToken) {
        login();
        Map<String, String> queries = new HashMap<>(4);
        queries.put("corpId", corpId);
        queries.put("pid", pid);
        queries.put("pageNum", "1");
        queries.put("pageSize", "1000");

        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + ACCESS_TOKEN);
        String json = okHttpUtil.get(api + "contact/v1/dept/pagelist", queries, headerParams);
        if(StringUtils.isNotEmpty(json)) {
            return JSON.parseObject(json, new TypeReference<Ret<MTDeptSubDeptUserPagelistRspDTO>>() {
            }).getData();
        }
        return null;
    }*/

    /**
     * 获取token接口
     */
    public void login() {
        Map<String, String> queries = new HashMap<>(1);
        queries.put("username", "15488888569");
        queries.put("password", "111222");

        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        String json = okHttpUtil.get(api + "app/login", queries, headerParams);
        if (StringUtils.isNotEmpty(json)) {
            Ret<Map<String, Object>> ret = JSON.parseObject(json, new TypeReference<Ret<Map<String, Object>>>() {
            });
            if (ret.getData() != null) {
                ACCESS_TOKEN = ret.getData().get("access_token").toString();
            } else {
                logger.error("token获取异常");
            }
        }
    }
}
