package com.zgiot.zx.workflow.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zgiot.zx.workflow.base.Ret;
import com.zgiot.zx.workflow.dto.MTEquipmentInfoRspDTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 设备接口
 * @author David
 */
@Component
public class MTEquipmentApiRequestClient {

    private static final Logger logger = LoggerFactory.getLogger(MTEquipmentApiRequestClient.class);

    @Autowired
    private OkHttpUtil okHttpUtil;

    @Value("${mt.api}")
    private String api;

    /**
     * 模糊搜索列表
     * @param equipmentCodeOrName
     * @param dimCode
     * @param corpId
     * @param accessToken
     * @return
     */
    public List<MTEquipmentInfoRspDTO> getEquipment(String equipmentCodeOrName, String dimCode, String corpId, String accessToken) {
        Map<String, String> queries = new HashMap<>(2);
        queries.put("dimCode", dimCode);

        Map<String, String> headerParams = new HashMap<>(3);
        headerParams.put("corpId", corpId);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + accessToken);
//        String json = okHttpUtil.get(api + "equipment/v1/data/getEquipment/" + equipmentCodeOrName, queries, headerParams);
        String json = "{\"code\":\"M0000\",\"ctime\":1560831201693,\"data\":[{\"corpId\":\"1115912149559242754\",\"createTime\":1560510880000,\"createUser\":\"122,1115912149777346561\",\"equipmentCode\":\"3123\",\"equipmentName\":\"6月10日\",\"equipmentNote\":\"11\",\"equipmentSpatial\":{\"canDelete\":1,\"createTime\":1559805649000,\"createUserUuid\":\"122,1115912149777346561\",\"equipmentProperties\":[{\"dimCode\":\"spatial_position\",\"flag\":false,\"id\":693,\"isEnable\":1,\"propName\":\"x\",\"propUuid\":\"xxxx\",\"value\":\"11\"},{\"dimCode\":\"spatial_position\",\"flag\":false,\"id\":694,\"isEnable\":1,\"propName\":\"y\",\"propUuid\":\"yyyy\",\"value\":\"200000\"}],\"id\":41,\"isEnable\":1,\"spaCode\":\"2343rrfd\",\"spaName\":\"位置定义-位置类型5月31日\",\"spaUuid\":\"spatial_position3d115ac1-5188-42e1-b48f-2703b0586d0b20190531151112\",\"updateTime\":1559805649000,\"updateUserUuid\":\"122\"},\"equipmentUuid\":\"equipmentb5503f61-52bd-439d-9a3b-b63963ac111e20190610090127\",\"id\":59,\"manufacturerUuid\":\"6acda105-e05c-4804-a97e-ec920e348d0d20190531151029\",\"organizationCode\":\"178\",\"organizationCodeList\":[\"178\"],\"principalsUuid\":\"113,124,127\",\"principalsUuidList\":[\"113\",\"124\",\"127\"],\"specifications\":\"434\",\"status\":1,\"tagUid\":\"\",\"updateTime\":1560510880000,\"useTime\":1560510880000},{\"corpId\":\"1115912149559242754\",\"createTime\":1560510882000,\"createUser\":\"122,1115912149777346561\",\"equipmentCode\":\"213123\",\"equipmentName\":\"2323s\",\"equipmentNote\":\"111\",\"equipmentSpatial\":{\"canDelete\":1,\"createTime\":1559805649000,\"createUserUuid\":\"122,1115912149777346561\",\"equipmentProperties\":[{\"dimCode\":\"spatial_position\",\"flag\":false,\"id\":693,\"isEnable\":1,\"propName\":\"x\",\"propUuid\":\"xxxx\",\"value\":\"11\"},{\"dimCode\":\"spatial_position\",\"flag\":false,\"id\":694,\"isEnable\":1,\"propName\":\"y\",\"propUuid\":\"yyyy\",\"value\":\"200000\"}],\"id\":41,\"isEnable\":1,\"spaCode\":\"2343rrfd\",\"spaName\":\"位置定义-位置类型5月31日\",\"spaUuid\":\"spatial_position3d115ac1-5188-42e1-b48f-2703b0586d0b20190531151112\",\"updateTime\":1559805649000,\"updateUserUuid\":\"122\"},\"equipmentUuid\":\"equipmentfe41b5e3-c7fa-4d06-bbec-a8d3891bd66620190610090520\",\"id\":60,\"manufacturerUuid\":\"6acda105-e05c-4804-a97e-ec920e348d0d20190531151029\",\"organizationCode\":\"178\",\"organizationCodeList\":[\"178\"],\"principalsUuid\":\"113,124,127\",\"principalsUuidList\":[\"113\",\"124\",\"127\"],\"specifications\":\"321323\",\"status\":1,\"tagUid\":\"\",\"updateTime\":1560510882000,\"updateUserUuid\":\"122,1115912149777346561\",\"useTime\":1560510882000}],\"message\":\"OK\"}";

        return JSON.parseObject(json, new TypeReference<Ret<List<MTEquipmentInfoRspDTO>>>() {
        }).getData();
    }

    /**
     * 查询所有的dimCode
     * @param corpId
     * @param accessToken
     * @return
     */
    public Map<String, Object> getDictionaryBySearch(String corpId, String accessToken) {
        Map<String, Object> queries = new HashMap<>(3);
        queries.put("name", "");
        queries.put("pageNum", 1);
        queries.put("pageSize", 1000);


        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("corpId", corpId);
        //headerParams.put("Authorization", "Bearer " + accessToken);
        //String json = okHttpUtil.postForJson(api + "equipment/v1/dictionary/getDictionaryBySearch?dictionaryCode=dim", queries, headerParams);

        String json = "{\"code\":\"M0000\",\"ctime\":1560830352136,\"data\":{\"rows\":[{\"code\":\"equipment_classification\",\"id\":1,\"name\":\"设备类型\"},{\"code\":\"spatial_position\",\"id\":2,\"name\":\"空间位置\"},{\"code\":\"technological_position\",\"id\":3,\"name\":\"工艺位置\"}],\"total\":3},\"message\":\"OK\"}";


        return JSON.parseObject(json, new TypeReference<Ret<Map<String, Object>>>() {
        }).getData();
    }

}
