package com.zgiot.zx.workflow.utils;

import com.zgiot.zx.workflow.dto.MTNotificationSendReqDTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * 消息通知接口调用
 * @author David
 */
@Component
public class MTNotificationApiRequestClient {

    static final Logger logger = LoggerFactory.getLogger(MTNotificationApiRequestClient.class);

    @Autowired
    private OkHttpUtil okHttpUtil;

    @Value("${mt.api}")
    private String api;

    /**
     * 发送通知
     * @param mtNotificationSendReqDTO
     * @param accessToken
     * @return
     */
    public String send(MTNotificationSendReqDTO mtNotificationSendReqDTO, String accessToken) {
        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + accessToken);
        return "success 发送成功";
//        return okHttpUtil.postForJson(api + "api/notification/v1/notification/send", JSON.toJSONString(mtNotificationSendReqDTO), headerParams);
    }

}
