package com.zgiot.zx.workflow.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zgiot.zx.workflow.base.Ret;
import com.zgiot.zx.workflow.dto.MTOssRspDTO;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.util.HashMap;
import java.util.Map;

/**
 * 消息通知接口调用
 * @author David
 */
@Component
public class MTOSSApiRequestClient {

    private static final Logger logger = LoggerFactory.getLogger(MTOSSApiRequestClient.class);

    @Autowired
    private OkHttpUtil okHttpUtil;

    @Value("${mt.api}")
    private String api;

    /**
     * 文件上传OSS，可以直接取url
     * @param file
     * @param accessToken
     * @return
     */
    public MTOssRspDTO upload(MultipartFile file, String accessToken) {
        Map<String, Object> map = new HashMap<>(3);
        map.put("file", file);
        map.put("bucket", "2");
        map.put("path", "2");
        Map<String, String> headerParams = new HashMap<>(2);
        headerParams.put("clientType", "app");
        headerParams.put("Authorization", "Bearer " + accessToken);
        String json = okHttpUtil.postFile(api + "oss/v1/file/upload", map, "multipart/form-data", headerParams);
        if(StringUtils.isNotEmpty(json)) {
            return JSON.parseObject(json, new TypeReference<Ret<MTOssRspDTO>>() {}).getData();
        }
        return null;
    }

}
